#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void update(vector<map<int, map<int, int>>> &dp, int x, int y, int z, int val) {
    if (dp[x].find(y) == dp[x].end() || dp[x][y].find(z) == dp[x][y].end()) {
        dp[x][y][z] = val;
    }
    else {
        dp[x][y][z] = min(dp[x][y][z], val);
    }
}

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    const int maxa = 100;
    vector<map<int, map<int, int>>> dp(n);

    dp[0][a[0]][0] = 0;

    for (int i = 0; i < n - 1; ++i) {
        for (auto h : dp[i]) {
            for (auto f : dp[i][h.first]) {
                int j = h.first;
                int k = f.first;
                if (dp[i][j][k] == 1e9) continue;

                if (j + a[i + 1] > 0) {
//                    dp[i + 1][a[i + 1]][k] = min(dp[i + 1][a[i + 1]][k], dp[i][j][k]);
                    update(dp, i + 1, a[i + 1], k, dp[i][j][k]);
                }
                else {
//                    dp[i + 1][a[i + 1]][k + 1] = min(dp[i + 1][a[i + 1]][k + 1], dp[i][j][k]);
//                    dp[i + 1][-j + 1][k] = min(dp[i + 1][-j + 1][k], dp[i][j][k] + (-j + 1) - a[i + 1]);
                    update(dp, i + 1, a[i + 1], k + 1, dp[i][j][k]);
                    update(dp, i + 1, -j + 1, k, dp[i][j][k] + (-j + 1) - a[i + 1]);
                }
            }
        }
    }

    vector<int> ans(n, 1e9);
    for (auto i : dp[n - 1]) {
        for (auto j : dp[n - 1][i.first]) {
            ans[j.first] = min(ans[j.first], j.second);
        }
    }

    for (ll i = 0; i + 1 < n; ++i) ans[i + 1] = min(ans[i + 1], ans[i]);

    for (auto i : ans) cout << i << ' ';
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}