#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void update(vector<map<int, map<int, int>>> &dp, int x, int y, int z, int val) {
    if (dp[x].find(y) == dp[x].end() || dp[x][y].find(z) == dp[x][y].end()) {
        dp[x][y][z] = val;
    }
    else {
        dp[x][y][z] = min(dp[x][y][z], val);
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    for (ll i = 0; i < n; ++i) --a[i];

    map<ll, ll> last_pos;
    for (ll i = 0; i < n; ++i) {
        last_pos[a[i]] = i;
    }

    vector<ll> b;
    ll now = 0;
    vector<set<ll>> gh;

    while (now != n) {
        gh.push_back({});
        ll mx = last_pos[a[now]];

        while (mx >= now) {
            gh.back().insert(a[now]);
            mx = max(mx, last_pos[a[now]]);
            now++;
        }
        b.push_back(now - 1);
    }

    vector<vector<ll>> cost(m, vector<ll> (m));
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) cin >> cost[i][j];
    }

    vector<vector<ll>> dp(b.size(), vector<ll> (m, INF));

    for (ll colour = 0; colour < m; ++colour) {
        dp[0][colour] = 0;
        for (auto i : gh[0]) dp[0][colour] += cost[i][colour];
    }

    for (ll i = 1; i < b.size(); ++i) {
        ll minn = INF;
        for (ll colour = 0; colour < m; ++colour) {
            minn = min(minn, dp[i - 1][colour]);
            ll need = 0;

            for (auto k : gh[i]) need += cost[k][colour];

            dp[i][colour] = minn + need;
        }
    }

    ll ans = INF;
    for (ll i = 0; i < m; ++i) ans = min(ans, dp[b.size() - 1][i]);
    cout << ans;
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}