#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

const ll MAXN = 100'000;
vector<ll> g[MAXN];
ll pr[MAXN], h[MAXN];

void dfs(ll v, ll p, ll now_h) {
    pr[v] = p;
    h[v] = now_h;

    for (auto i : g[v]) {
        if (i == p) continue;

        dfs(i, v, now_h + 1);
    }
}

void solve() {
    ll n;
    cin >> n;

    for (ll i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;

        --u, --v;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(0, -1, 0);

    ll q, t;
    cin >> q >> t;
    ll last_ans = 0;

    while (q--) {
        ll k;
        cin >> k;
        vector<pair<ll, ll>> car(k);
        for (ll i = 0; i < k; ++i) {
            cin >> car[i].first >> car[i].second;
            if (t == 2) {
                car[i].first += last_ans;
                car[i].first %= (n - 1);
                car[i].first += 2;
            }
            --car[i].first;
        }

        map<ll, ll> now_c;
        map<ll, vector<ll>> by_h;
        set<ll> used;
        for (auto i : car) {
            by_h[h[i.first]].push_back(i.first);
            now_c[i.first] = i.second;
        }

        ll ans = 0;
        while (by_h.size()) {
            ll real_h = (--by_h.end())->first;
            ll now_v = by_h[real_h].back();
            by_h[real_h].pop_back();
            if (by_h[real_h].size() == 0) by_h.erase(real_h);
            if (used.find(now_v) != used.end()) continue;
            ans = max(ans, (h[now_v] + 1) * now_c[now_v]);
            if (pr[now_v] != -1) {
                now_c[pr[now_v]] += now_c[now_v];
                by_h[real_h - 1].push_back(pr[now_v]);
            }
            used.insert(now_v);
        }

        cout << ans << '\n';
        last_ans = ans;
    }
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}