#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

void findPrimes(uint32_t n, vector<uint32_t>& primes) {
    primes.emplace_back(2);
    uint32_t sz = (n-1)/2;
    uint8_t* isPrime = new uint8_t[sz+1];
    memset(isPrime, 1, sz+1);
    for (uint32_t i = 1; i <= sz; ++i) {
        if (isPrime[i]) {
            uint32_t p = 2*i+1;
            primes.emplace_back(p);
            uint32_t jmax = (sz-i)/p;
            for (uint32_t j = i; j <= jmax; ++j) {
                isPrime[p*j+i] = 0;
            }
        }
    }
    delete[] isPrime;
}

bool ok(uint64_t n, vector<uint32_t> primes) {
    uint32_t k = 0;
    for (auto p : primes) {
        if (p*p > n) {
            break;
        }
        uint32_t cnt = 0;
        while (n%p == 0) {
            n /= p;
            ++cnt;
        }
        //cout << p << ' ' << cnt << '\n';
        if (cnt%2) {
            ++k;
            if (k > 1) {
                return false;
            }
        }
    }
    if (n > 1) {
        //cout << n << ' ' << 1 << '\n';
        ++k;
    }
    //cout << n << ' ' << (k<2) << '\n';
    return (k < 2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    uint32_t up = 70712;
    vector<uint32_t> primes;
    primes.reserve(7010);
    findPrimes(up, primes);

    uint32_t n, m; cin >> n >> m;
    vector<uint64_t> pref(n+1);
    pref[0] = 0;
    for (uint32_t i = 1; i <= n; ++i) {
        pref[i] = pref[i-1]+(n-i+1);
    }
    vector<vector<uint32_t>> ans;
    uint32_t i = 0;
    while (i < n) {
        uint32_t ma = i+1;
        for (uint32_t j = n; j>i; --j) {
            if (ok(pref[j]-pref[i], primes)) {
                ma = j;
                break;
            }
        }
        ans.emplace_back();
        for (uint32_t k = i; k<ma; ++k) {
            ans.back().push_back(n-k);
        }
        i = ma;
    }
    cout << ans.size() << '\n';
    for (auto& i : ans) {
        cout << i.size() << '\n';
        for (auto j : i) {
            cout << j << ' ';
        }
        cout << '\n';
    }

    return 0;
}