﻿#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int S = 20, R = (1 << S);
int lgg[R];

struct lca {
    vi h, a, b, o;
    vector<vi> sp;

    void dfs(vector<vi> &g, int u = 0, int p = -1, int x = 0) {
        h[u] = x;
        a[u] = (int)o.size();
        o.push_back(u);
        for (int v: g[u]) {
            if (v != p) {
                dfs(g, v, u, x + 1);
                o.push_back(u);
            }
        }
        b[u] = (int)o.size() - 1;
    }

    lca(int n, vector<vi> &g) {
        h.resize(n);
        a.resize(n);
        b.resize(n);
        dfs(g);
        sp.assign(o.size(), vi(S));
        for (int i = 0; i < (int)o.size(); ++i)
            sp[i][0] = o[i];
        for (int s = 1; s < S; ++s) {
            for (int i = 0; i + (1 << s) <= (int)o.size(); ++i) {
                if (h[sp[i][s - 1]] < h[sp[i + (1 << (s - 1))][s - 1]])
                    sp[i][s] = sp[i][s - 1];
                else
                    sp[i][s] = sp[i + (1 << (s - 1))][s - 1];
            }
        }
    }

    int get_lca(int u, int v) {
        if (a[u] > a[v])
            swap(u, v);
        int l = lgg[a[v] - a[u] + 1];
        if (h[sp[a[u]][l]] < h[sp[a[v] - (1 << l) + 1][l]])
            return sp[a[u]][l];
        else
            return sp[a[v] - (1 << l) + 1][l];
    }
};

ll t[R * 2];

void update(int i, ll x) {
    int v = R + i;
    t[v] += x;
    v >>= 1;
    while (v > 0) {
        t[v] = t[v << 1] + t[(v << 1) ^ 1];
        v >>= 1;
    }
}

ll get_sum(int l, int r) {
    l += R;
    r += R;
    ll res = 0;
    while (l < r) {
        if (l & 1) {
            res += t[l];
            ++l;
        }
        if (!(r & 1)) {
            res += t[r];
            --r;
        }
        l >>= 1;
        r >>= 1;
    }
    if (l == r)
        res += t[l];
    return res;
}

int main() {
    fast;
    lgg[1] = 0;
    for (int i = 2; i < R; ++i)
        lgg[i] = lgg[i >> 1] + 1;
    int n;
    cin >> n;
    vector<vi> g(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    lca lc(n, g);
    int q, tp;
    cin >> q >> tp;
    ll ans = 0;
    while (q--) {
        int k;
        cin >> k;
        ll x = 0;
        tuple<int, int, ll> a[k];
        for (int i = 0; i < k; ++i) {
            int v;
            ll c;
            cin >> v >> c;
            if (tp == 1)
                --v;
            else
                v = (v + ans) % (n - 1) + 1;
            a[i] = {lc.a[v], v, c};
            x = max(x, (ll)(lc.h[v] + 1) * c);
            update(lc.a[v], c);
        }
        sort(a, a + k);
        for (int i = 1; i < k; ++i) {
            int l = lc.get_lca(get<1>(a[i - 1]), get<1>(a[i]));
            x = max(x, (ll)(lc.h[l] + 1) * get_sum(lc.a[l], lc.b[l]));
        }
        for (int i = 0; i < k; ++i)
            update(lc.a[get<1>(a[i])], -get<2>(a[i]));
        cout << x << '\n';
        ans = x;
    }
}
