#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ll = long long;
#define int ll 
#define all(a) a.begin(), a.end()

using namespace std;

vector<int> par;

int find(int v) {
    return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
    u = find(u);
    v = find(v);
    if (u == v) return;
    par[u] = v;
}

void solve() {
    int n, m;
    cin >> n >> m;
    par.resize(n);
    iota(all(par), 0);
    vector<int> a(n);
    vector<int> rp(m, -1);
    vector<vector<int>> pos(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        rp[a[i]] = i;
        pos[a[i]].push_back(i);
    }
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    for (int i = 0; i < n - 1; i++) {
        if (i != rp[a[i]]) {
            unite(i, i + 1);
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j + 1 < pos[i].size(); j++) {
            unite(pos[i][j], pos[i][j + 1]);
        }
    }
    vector<vector<int>> pr(n);
    for (int i = 0; i < m; i++) {
        if (rp[i] != -1) {
            pr[find(rp[i])].push_back(i);
        }
    }
    vector<vector<int>> p1;
    for (int i = 0; i < n; i++) {
        if (pr[i].size()) {
            p1.push_back(pr[i]);
        }
    }
    vector<vector<int>> dp(p1.size(), vector<int>(m, 1e18));
    vector<vector<int>> pmi(p1.size(), vector<int>(m, 1e18));
    for (int y = 0; y < m; y++) {
        int c = 0;
        for (auto x : p1[0]) {
            c += cost[x][y];
        }
        dp[0][y] = c;
        pmi[0][y] = dp[0][y];
        if (y) {
            pmi[0][y] = min(pmi[0][y-1], dp[0][y]);
        }
    }
    for (int i = 1; i < p1.size(); i++) {
        for (int y = 0; y < m; y++) {
            int c = 0;
            for (auto x : p1[i]) {
                c += cost[x][y];
            }
            dp[i][y] = c + pmi[i-1][y];
            pmi[i][y] = dp[i][y];
            if (y) {
                pmi[i][y] = min(pmi[i][y - 1], dp[i][y]);
            }
        }
    }
    cout << pmi.back().back();
}

signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    int t;
    t = 1;// cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}