#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define int long long
#define ll long long
#define ld long double

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct Edge {
    int v, u;
    int vu;
    Edge(int _v, int _u) {
        v = _v;
        u = _u;
        vu = v + u;
    }
    int to(int x) {
        return vu - x;
    }
};

int spow(int a, int p = MOD - 2) {
    if (p == 0) return 1;
    if (p == 1) return a;
    int o = spow(a, p / 2);
    o = o * o % MOD;
    if (p % 2) o = o * a % MOD;
    return o;
}
vector<int> fact, rfact;
void build_f() {
    int n = 1e5 + 1;
    fact.resize(n);
    rfact.resize(n);
    fact[0] = 1;
    for (int i = 1; i < n; i++) fact[i] = fact[i - 1] * i % MOD;
    rfact[n - 1] = spow(fact[n - 1]);
}

vector<Edge> eds;
vector<vector<int>> gr;
vector<int> used;
void dfs(int x) {
    if (used[x]) return;
    used[x] = 1;
    for (int e : gr[x]) {
        dfs(eds[e].to(x));
    }
}

void solve0() {
    int n, m; cin >> n >> m;
    if (n == 1) cout << 1 << '\n';
    else cout << 2 << '\n';
    cout << (n + 1) / 2 << '\n';
    for (int i = 1; i <= n; i += 2) cout << i << ' '; cout << '\n'; 
    if (n == 1) return;
    cout << n / 2 << '\n';
    for (int i = 2; i <= n; i += 2) cout << i << ' ';
}

void solve() {
    int a, b, n, m; cin >> a >> b >> n >> m;
    if (a * 2 != b) {
        m -= 2 * n;
        b -= 2*a;
        if (b * m < 0) {cout << -1 << '\n'; return;}
        m = abs(m);
        b = abs(b);
        if (m % b) {cout << -1 << '\n'; return;}
        int d = m / b;
        if (d * a > n) {cout << -1 << '\n'; return;}
        cout << n - (d * a) << ' ' << d << '\n';
    }
    else {
        if (2 * n != m) cout << -1 << '\n';
        else cout << n << ' ' << 0 << '\n'; 
    } 
}

signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}