#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define int long long
#define ll long long
#define ld long double

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct Edge {
    int v, u;
    int vu;
    Edge(int _v, int _u) {
        v = _v;
        u = _u;
        vu = v + u;
    }
    int to(int x) {
        return vu - x;
    }
};

int spow(int a, int p = MOD - 2) {
    if (p == 0) return 1;
    if (p == 1) return a;
    int o = spow(a, p / 2);
    o = o * o % MOD;
    if (p % 2) o = o * a % MOD;
    return o;
}
vector<int> fact, rfact;
void build_f() {
    int n = 1e5 + 1;
    fact.resize(n);
    rfact.resize(n);
    fact[0] = 1;
    for (int i = 1; i < n; i++) fact[i] = fact[i - 1] * i % MOD;
    rfact[n - 1] = spow(fact[n - 1]);
}

vector<Edge> eds;
vector<vector<int>> gr;
vector<int> used;
void dfs(int x) {
    if (used[x]) return;
    used[x] = 1;
    for (int e : gr[x]) {
        dfs(eds[e].to(x));
    }
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int& i : a) cin >> i;
    for (int& i : b) cin >> i;
    for (int& i : c) cin >> i;
    for (int& i : d) cin >> i;
    vector<int> dp1(n + 1), dp2(n + 1);
    dp2[0] = INF;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            dp1[i + 1] = min(dp1[i] + c[i], dp2[i] + d[i]);
            dp2[i + 1] = min(dp1[i] + d[i], dp2[i] + c[i]);
        } if (a[i] > 0) {
            int dt = a[i] / b[i] + 1;
            dp1[i + 1] = min(dp1[i], dp2[i] + dt * d[i]);
            dp2[i + 1] = min(dp2[i], dp1[i] + dt * d[i]);
        } if (a[i] < 0) {
            int dt = abs(a[i]) / b[i] + 1;
            dp2[i + 1] = min(dp1[i], dp2[i] + dt * c[i]);
            dp1[i + 1] = min(dp2[i], dp1[i] + dt * c[i]);
        }
    }
    cout << dp1.back() << '\n';
    /*int a, b, n, m; cin >> a >> b >> n >> m;
    if (a * 2 > b) {
        int l = -1, r = n + 1;
        while (l + 1 != r) {
            int md = (l + r) / 2;
            int _n = n - md;
            int _m = m - 2 * md;
            ld d = (ld)a / b - (ld)_n / _m;
            if (d > -EPS) {
                l = md;
            } else {
                r = md;
            }
        }
        //cout << l << '\n';
        if (l == -1) cout << -1 << '\n';
        else {
            n -= l;
            m -= 2 * l;
            if (n % a || m % b || b * n != a * m) cout << -1 << '\n';
            else cout << l << ' ' << n << '\n';
        }
    }
    else if (a * 2 < b) {
        int l = -1, r = n + 1;
        while (l + 1 != r) {
            int md = (l + r) / 2;
            int _n = n - md;
            int _m = m - 2 * md;
            ld d = (ld)a / b - (ld)_n / _m;
            if (d < EPS) {
                l = md;
            } else {
                r = md;
            }
        }
        //cout << l << '\n';
        if (l == -1) cout << -1 << '\n';
        else {
            n -= l;
            m -= 2 * l;
            if (n % a || m % b || b * n != a * m) cout << -1 << '\n';
            else cout << l << ' ' << n << '\n';
        }
    }
    else {
        if (2 * n != m) cout << -1 << '\n';
        else cout << n << ' ' << 0 << '\n'; 
    }
/*
n - k % a == 0
m - 2k % b == 0
n / m == a / b


*/ 
}

signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}