#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#define int long long
#define ll long long
#define ld long double

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct Edge {
    int v, u;
    int vu;
    Edge(int _v, int _u) {
        v = _v;
        u = _u;
        vu = v + u;
    }
    int to(int x) {
        return vu - x;
    }
};

int spow(int a, int p = MOD - 2) {
    if (p == 0) return 1;
    if (p == 1) return a;
    int o = spow(a, p / 2);
    o = o * o % MOD;
    if (p % 2) o = o * a % MOD;
    return o;
}
vector<int> fact, rfact;
void build_f() {
    int n = 1e5 + 1;
    fact.resize(n);
    rfact.resize(n);
    fact[0] = 1;
    for (int i = 1; i < n; i++) fact[i] = fact[i - 1] * i % MOD;
    rfact[n - 1] = spow(fact[n - 1]);
}

vector<Edge> eds;
vector<vector<int>> gr;
vector<int> used;
void dfs(int x) {
    if (used[x]) return;
    used[x] = 1;
    for (int e : gr[x]) {
        dfs(eds[e].to(x));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> ans;
    for (int i = 1; i <= n; i <<= 1) {
        ans.push_back(vector<int>());
        for (int j = i; j <= n; j += 2 * i)
        ans.back().push_back(j);
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].size() << '\n';
        for (int j : ans[i]) cout << j << ' '; cout << '\n';
    }
}

signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}