#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#define int long long
#define ll long long
#define ld long double

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct Edge {
    int v, u;
    int vu;
    Edge(int _v, int _u) {
        v = _v;
        u = _u;
        vu = v + u;
    }
    int to(int x) {
        return vu - x;
    }
};

int spow(int a, int p = MOD - 2) {
    if (p == 0) return 1;
    if (p == 1) return a;
    int o = spow(a, p / 2);
    o = o * o % MOD;
    if (p % 2) o = o * a % MOD;
    return o;
}
vector<int> fact, rfact;
void build_f() {
    int n = 1e5 + 1;
    fact.resize(n);
    rfact.resize(n);
    fact[0] = 1;
    for (int i = 1; i < n; i++) fact[i] = fact[i - 1] * i % MOD;
    rfact[n - 1] = spow(fact[n - 1]);
}

vector<Edge> eds;
vector<vector<int>> gr;
vector<int> used;
void dfs(int x) {
    if (used[x]) return;
    used[x] = 1;
    for (int e : gr[x]) {
        dfs(eds[e].to(x));
    }
}

void solve0() {
    int n, m; cin >> n >> m;
    if (n == 1) cout << 1 << '\n';
    else cout << 2 << '\n';
    cout << (n + 1) / 2 << '\n';
    for (int i = 1; i <= n; i += 2) cout << i << ' '; cout << '\n'; 
    if (n == 1) return;
    cout << n / 2 << '\n';
    for (int i = 2; i <= n; i += 2) cout << i << ' ';
}

void solve() {
    int n, m; cin >> n >> m;
    vector<int> col(n);
    int st = -1;
    vector<vector<int>> mt(1);
    map<int, int> mp;
    for (int i = 0; i < n; i++) {cin >> col[i]; col[i]--; mp[col[i]] = i;}
    vector<int> ch(m);
    for (int i = 0; i < n; i++) {
        if (ch[col[i]]) continue;
        ch[col[i]] = 1;
        if (st < i) mt.push_back(vector<int>());
        st = max(st, mp[col[i]]);
        mt.back().push_back(col[i]);
    }
    vector<vector<int>> mtr(m, vector<int> (m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mtr[i][j];
        }
    }
    vector<vector<int>> dp(mt.size(), vector<int> (m, 0));
    //for (auto& v : mt) {for (int i : v) cout << i << ' '; cout << '\n';}
    //cout << "ok1" << endl;
    for (int i = 1; i < mt.size(); i++) {
        for (int k : mt[i]) for (int j = 0; j < m; j++) {
            dp[i][j] += mtr[k][j];
            //cout << i << j << ' ' << k << j << endl;
        }
        //cout << "ok2" << endl;
    }
    //cout << "ok" << endl;
    
    //for (auto& v : dp) {for (int i : v) cout << i << ' '; cout << '\n';}

    for (int i = 1; i < mt.size(); i++) {
        //if (i != 1) dp[i][0] = INF;
        dp[i][0] = dp[i][0] + dp[i-1][0];
        for (int j = 1; j < m; j++) {
            dp[i][j] = min(dp[i][j - 1], dp[i][j] + dp[i - 1][j]);
        }
    }
    cout << dp.back().back() << '\n';
}

signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}