#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;
const int N = 3000;

int n;
vector<vector<int>> g(N);
vector<ll> dp;
ll ans;

void dfs(int v, int p, ll d) {
    for (int to : g[v]) {
        if (to != p) {
            dfs(to, v, d + 1);
            dp[v] += dp[to];
        }
    }
    ans = max(ans, d * dp[v]);
}

void solve() {
    dp.assign(n, 0LL);
    ans = 0;
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        int v, c;
        cin >> v >> c;
        v--;
        dp[v] += c;
    }
    dfs(0, -1, 1);
    cout << ans << '\n';
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int q, t;
    cin >> q >> t;
    while (q--) {
        solve();
    }
}