#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

// это решается сжатым деревом. филип объяснял сжатое дерево. я не помню и не умею писать сжатое дерево. 😭😭

const int maxn = 4e5 + 5;
vector<int> g[maxn];
set<int> gc[maxn];
int bup[maxn][20];
int tin[maxn], tout[maxn];
int timer = 1;

void dfsinit(int v = 1, int prev = -1) {
    tin[v] = timer++;
    if (v != 1) {
        for (int i = 1; i < 20; i++) {
            bup[v][i] = bup[bup[v][i-1]][i-1];
        }
    } else {
        for (int i = 0; i < 20; i++) {
            bup[v][i] = v;
        }
    }

    for (int u : g[v]) {
        if (u == prev) continue;
        bup[u][0] = v;
        dfsinit(u, v);
    }
    tout[v] = timer++;
}

bool ispred(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int u, int v) {
    if (ispred(u, v)) return u;
    if (ispred(v, u)) return v;

    for (int i = 19; i >= 0; i--) {
        if (!ispred(bup[u][i], v))
            u = bup[u][i];
        if (!ispred(bup[v][i], u))
            v = bup[v][i];
    }

    return bup[v][0];
}

int dist(int v) {
    if (v == 1) return 0;
    int cur = 0;
    for (int i = 19; i >= 0; i--) {
        if (bup[v][i] == 1) continue;
        cur += (1 << i);
        v = bup[v][i];
    }
    return cur + 1;
}

int c[maxn];
pair<int, int> dfsq(int v, int pr = -1) {
    int cnt = c[v];
    int ans = 0;
    for (int u : gc[v]) {
        if (u == v || u == pr) continue;
        auto [a, b] = dfsq(u);
        cnt += a;
        ans = max(ans, b);
    }
    ans = max(ans, cnt * (dist(v) + 1));
    return {cnt, ans};
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n-1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfsinit();
    int q, t;
    cin >> q >> t;
    int last = 0;
    while (q--) {
        int k;
        cin >> k;
        vector<pair<int, int>> vec(k);
        vector<int> td;
        for (int i = 0; i < k; i++) {
            cin >> vec[i].first >> vec[i].second;
            if (t == 2)
                vec[i].first = (vec[i].first + last) % (n - 1) + 2;
            c[vec[i].first] = vec[i].second;
        }
        sort(vec.begin(), vec.end(), [&](auto& a, auto& b) {
            return tout[a.first] < tout[b.first];
        });

        int root = vec[0].first;
        vector<int> stack = {vec[0].first};
        for (int i = 1; i < k; i++) {
            auto [u, c] = vec[i];
            bool fl = false;

            if (ispred(stack.back(), u)) {
                fl = true;
                gc[stack.back()].insert(u);
                td.push_back(stack.back());
                stack.push_back(u);
            }

            while (stack.size() > 1) {
                if (fl) break;
                int l = lca(u, stack.back());
                if (ispred(stack[stack.size()-2], l)) {
                    fl = true;
                    if (l == stack[stack.size()-2]) {
                        td.push_back(stack[stack.size()-2]);
                        td.push_back(l);
                        gc[stack[stack.size()-2]].insert(u);
                        gc[l].insert(u);
                        stack.pop_back();
                        stack.push_back(u);
                        break;
                    } else {
                        td.push_back(stack[stack.size()-2]);
                        gc[stack[stack.size()-2]].erase(stack.back());
                        gc[stack[stack.size()-2]].insert(l);
                        td.push_back(l);
                        gc[l].insert(stack.back());
                        gc[l].insert(u);
                        stack.pop_back();
                        stack.push_back(l);
                        stack.push_back(u);
                        break;
                    }
                } else {
                    stack.pop_back();
                }
            }

            if (!fl) {
                int l = lca(u, stack.back());
                if (ispred(l, stack.back())) {
                    root = l;
                    td.push_back(l);
                    gc[l].insert(stack.back());
                    stack.pop_back();
                    stack.push_back(l);
                    stack.push_back(u);
                    gc[l].insert(u);
                } else {
                    td.push_back(stack.back());
                    td.push_back(l);
                    gc[stack.back()].insert(l);
                    gc[l].insert(u);
                    stack.push_back(l);
                    stack.push_back(u);
                }
            }
        }
        last = dfsq(root).second;
        cout << last << '\n';
        for (int i = 0; i < k; i++) {
            c[vec[i].first] = 0;
        }
        for (int i : td) gc[i].clear();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}