#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

template<typename NodeType>
class Segtree {
public:
    template<typename InputType>
    explicit Segtree(int n, vector<InputType> a) {
        t.resize(4 * n + 1);
        size = n;
        build(a, 0, 0, n);
    }

    NodeType get(int l, int r) {
        return get(0, 0, size, l, r);
    }

    template<typename InputType>
    void update(int i, InputType x) {
        update(0, 0, size, i, x);
    }

private:
    int size;
    vector<NodeType> t;

    template<typename InputType>
    void build(const vector<InputType> &arr, int v, int l, int r) {
        if (r - l == 1) {
            t[v] = NodeType(arr[l]);
            return;
        }

        int m = (l + r) / 2;
        build(arr, 2 * v + 1, l, m);
        build(arr, 2 * v + 2, m, r);

        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    NodeType get(int v, int l, int r, int ql, int qr) {
        if (r <= ql or qr <= l) return NodeType();
        if (ql <= l and r <= qr) return t[v];

        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }

    template<typename InputType>
    void update(int v, int l, int r, int i, InputType x) {
        if (r - l == 1) {
            t[v] = NodeType(x);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) update(2 * v + 1, l, m, i, x);
        else update(2 * v + 2, m, r, i, x);

        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, m;
    cin >> n >> m;

    vector<int> a(n);
    cin >> a;

    for (int i = 0; i < n; ++i) {
        a[i]--;
    }

    vector<vector<int>> cost(m, vector<int>(m));
    cin >> cost;

    vector<vector<ll>> dp(n, vector<ll>(m, 1e18));
    for (int i = 0; i < m; ++i) {
        dp[0][i] = cost[a[0]][i];
    }
    for (int i = 1; i < n; ++i) {
        ll minn = 1e18;
        for (int j = 0; j < m; ++j) {
            minn = min(minn, dp[i - 1][j]);
            dp[i][j] = min(dp[i][j], minn + cost[a[i]][j]);
        }
    }

    cout << *std::min_element(dp[n - 1].begin(), dp[n - 1].end());
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion