#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;

        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }

    vector<int> dist(n);
    vector<int> par(n, -1);
    dist[0] = 1;
    function<void(int, int)> dfs_dist = [&](int v, int prev){
        for (auto u: g[v]){
            if (u==prev) continue;
            dist[u] = dist[v] + 1;
            par[u] = v;
            dfs_dist(u, v);
        }
    };
    dfs_dist(0, 0);

    ll lastans = 0;

    int q, t;
    cin >> q >> t;

    vector<ll> costs(n);
    function<void(int, ll)> go_up = [&](int start, ll c){
        int v = start;
        while (v != -1){
            costs[v] += dist[v] * c;
            v = par[v];
        }
    };
    assert(t==1);
    while (q--){
        int cn;
        cin >> cn;

        costs.assign(n, 0);

        for (int i = 0; i < cn; ++i) {
            int u, c;
            if (t==1){
                cin >> u >> c;
                u--;
            }
            go_up(u, c);
        }


        cout << *std::max_element(costs.begin(), costs.end()) << "\n";
    }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion