#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n;
    cin >> n;

    vector<ll> a(n), b(n), c(n), d(n);

    for (ll i = 0; i < n; i++) cin >> a[i];
    for (ll i = 0; i < n; i++) cin >> b[i];
    for (ll i = 0; i < n; i++) cin >> c[i];
    for (ll i = 0; i < n; i++) cin >> d[i];

    vector<ll> costUp(n), costDown(n);
    for (ll i = 0; i < n; i++) {
        if (a[i] == 0) {
            costUp[i] = c[i];
            costDown[i] = d[i];
        } else if (a[i] > 0) {
            costDown[i] = ((a[i] + b[i]) / b[i]) * d[i];
        } else {
            costUp[i] = ((-a[i] + b[i]) / b[i]) * c[i];
        }
    }

    vector<vector<ll>> dp(n, vector<ll>(2, INF));
    dp[0][0] = costDown[0];
    dp[0][1] = costUp[0];

    for (ll i = 1; i < n; i++) {
        for (ll pv = 0; pv < 2; pv++) {
            for (ll nw = 0; nw < 2; nw++) {
                if (pv == nw)
                    dp[i][nw] = min(dp[i][nw], dp[i - 1][pv] + costUp[i]);
                else
                    dp[i][nw] = min(dp[i][nw], dp[i - 1][pv] + costDown[i]);
            }
        }
    }

    cout << dp[n - 1][1];

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}