#pragma GCC optimize("O3,Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    auto isGood = [&] (ll n) {
        if (n == 1) return true;

        ll v = n;
        vector<ll> d;
        for (ll j = 2; j * j <= v; j++) {
            if (v % j) continue;
            ll y = n / j;
            ll z = sqrt(y);
            if (z * z == y) return true;
            while (v % j == 0) v /= j;
        }

        if (v > 1) {
            ll y = n / v;
            ll z = sqrt(y);
            if (z * z == y) return true;
        }

        return false;
    };

    auto sum = [&] (ll n) {
        return n * (n + 1) / 2;
    };

    ll n;
    cin >> n;

    ll z1 = sqrt(n + 1);
    if (z1 * z1 == n + 1 && n % 2 == 0) {
        cout << n / 2 << "\n";
        for (ll i = 0; i < n / 2; i++) {
            cout << "2\n";
            cout << i + 1 << " " << n - i << "\n";
        }

        return 0;
    }

    vector<ll> pv(n + 1, -1);
    pv[0] = 0;

    for (ll i = 1; i <= n; i++) {
        for (ll j = i - 1; j >= 0; j--) {
            if (pv[j] == -1) continue;
            if (!isGood(sum(i) - sum(j))) continue;
            pv[i] = j;
            break;
        }
    }

    vector<vector<ll>> ans;

    ll nw = n;

    while (nw > 0) {
        ans.emplace_back();
        for (ll i = pv[nw] + 1; i <= nw; i++) ans.back().push_back(i);
        nw = pv[nw];
    }

    cout << ans.size() << "\n";
    for (auto &q : ans) {
        cout << q.size() << "\n";
        for (auto x : q) cout << x << " ";
        cout << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}