#pragma GCC optimize("O3,Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>
#include <queue>
#include <random>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
#define mp make_pair

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

mt19937 gen(123);

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n;
    cin >> n;

    vector<ll> aNorm(n), a(n);
    for (ll i = 0; i < n; i++) cin >> aNorm[i];

    vector<vector<ll>> cost(n, vector<ll>(n, 0));

    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            a = aNorm;
            ll ans = 0;

            vector<queue<ll>> q(3);
            for (ll k = i; k <= j; k++) {
                ll c = 0;
                if (k - 1 >= i && a[k] + a[k - 1] <= 0) c++;
                if (k + 1 <= j && a[k] + a[k + 1] <= 0) c++;

                if (c > 0) q[c].push(k);
            }

            ll nwQ = 2;

            while (nwQ > -1) {
                while (q[nwQ].empty()) {
                    nwQ--;
                    if (nwQ < 0) break;
                }

                if (nwQ < 0) break;

                ll c = nwQ;
                ll k = q[c].front();
                q[c].pop();

                if (c == 0) break;

                ll cn = 0;
                if (k - 1 >= i && a[k] + a[k - 1] <= 0) cn++;
                if (k + 1 <= j && a[k] + a[k + 1] <= 0) cn++;

                if (c != cn) {
                    if (cn > 0) q[cn].push(k);
                    continue;
                }

                ll mn = INF;
                if (k - 1 >= i && a[k] + a[k - 1] <= 0)
                    mn = min(mn, 1 - (a[k] + a[k - 1]));
                if (k + 1 <= j && a[k] + a[k + 1] <= 0)
                    mn = min(mn, 1 - (a[k] + a[k + 1]));

                a[k] += mn;
                ans += mn;

                ll cx = 0;
                if (k - 1 >= i && a[k] + a[k - 1] <= 0) cx++;
                if (k + 1 <= j && a[k] + a[k + 1] <= 0) cx++;

                if (cx > 0) q[cx].push(k);
            }

            cost[i][j] = ans;
        }
    }

    vector<vector<ll>> dp(n, vector<ll>(n, INF));
    dp[0][0] = 0;

    for (ll i = 0; i < n; i++) {
        for (ll k = 0; k < n; k++) {
            if (dp[i][k] == INF) continue;

            for (ll gt = i + 1; gt < n; gt++) {
                dp[gt][k + gt - i] = min(dp[gt][k + gt - i], dp[i][k] + cost[i][gt]);

                dp[gt][k] = min(dp[gt][k], dp[i][k]);
            }
        }
    }

    for (ll i = n - 1; i >= 0; i--) cout << dp[n - 1][i] << " ";

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}