#pragma GCC optimize("O3,Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

vector<vector<ll>> g;
vector<ll> p, d;

void dfs(ll v, ll pv) {
    d[v] = (pv == -1 ? 0 : d[pv] + 1);
    p[v] = pv;

    for (ll to : g[v]) {
        if (to != pv) dfs(to, v);
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n;
    cin >> n;

    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    p.assign(n, -1);
    d.assign(n, -1);
    dfs(0, -1);

    ll q, t;
    cin >> q >> t;

    ll ans = 0, last = 0;

    vector<ll> sm(n);

    vector<ll> used(n, -100);

    while (q--) {
        ll k;
        cin >> k;

        ans = 0;

        while (k--) {
            ll v, c;
            cin >> v >> c;

            if (t == 1) {
                v--;
            } else {
                v = (v + last) % (n - 1) + 1;
            }

            while (v != -1) {
                if (used[v] != q) {
                    used[v] = q;
                    sm[v] = 0;
                }

                sm[v] += c;
                ans = max(ans, sm[v] * (d[v] + 1));

                v = p[v];
            }
        }

        cout << (last = ans) << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}