#pragma GCC optimize("O3,Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll MX = 1 << 18;

    vector<ll> dp(MX + 1);
    dp[0] = 0;

    for (ll i = 1; i <= MX; i++) {
        if (i % 2 == 0) {
            dp[i] = dp[i - 1] == 0;
        } else {
            vector<ll> q = {dp[i - 1], dp[i / 2]};
            std::sort(q.begin(), q.end());
            if (q[0] > 0) dp[i] = 0;
            else if (q[0] == 0 && q[1] != 1) dp[i] = 1;
            else dp[i] = 2;
        }
    }

    ll n, q;
    cin >> n >> q;

    vector<string> s(n);
    for (ll i = 0; i < n; i++) cin >> s[i];

    auto solve = [&] () {
        ll x = 0;
        for (ll i = 0; i < n; i++) x ^= dp[bitset<18>(s[i]).to_ullong()];

        cout << (x > 0 ? "First" : "Second") << "\n";
    };

    solve();

    while (q--) {
        ll l, r;
        cin >> l >> r;
        l--, r--;

        ll ptr = 0;
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < s[i].size(); j++) {
                if (l <= ptr + j && ptr + j <= r) s[i][j] = '0' + '1' - s[i][j];
            }

            ptr += s[i].size();
        }

        solve();
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}