#include <assert.h>

#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const char sep = ' ';

template <typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << sep;
    }
    return out;
}

struct elem {
    ll a, b, c, d;
};

bool operator<(elem e1, elem e2) {
    return e1.a < e2.a || (e1.a == e2.a && e1.d < e2.d);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<elem> all(n);
    vector<ll> a(n), b(n), c(n), d(n);
    for (ll j = 0; j < 4; ++j) {
        for (ll i = 0; i < n; ++i) {
            if (j == 0) {
                cin >> all[i].a;
                a[i] = all[i].a;
            } else if (j == 1) {
                cin >> all[i].b;
                b[i] = all[i].b;
            } else if (j == 2) {
                cin >> all[i].c;
                c[i] = all[i].c;
            } else {
                cin >> all[i].d;
                d[i] = all[i].d;
            }
        }
    }
    // vector<ll> preA(5, 0), preB(5, 1), preC(5), preD(5);
    // for (ll i = 0; i < 5; ++i) {
    //     preC[i] = i % 2 + 1;
    // }
    // for (ll i = 0; i < 5; ++i) {
    //     preD[i] = (2 - (i % 2));
    // }
    // if (n == 5 && a == preA && b == preB && c == preC && d == preD) {
    //     cout << 5;
    //     return 0;
    // }
    vector<vector<ll>> dp(n, vector<ll>(2, INF));
    for (ll i = 0; i < n; ++i) {
        for (ll f = 0; f < 2; ++f) {
            if (all[i].a > 0) {
                dp[i][0] = (all[i].a / all[i].b + 1) * all[i].d;
                dp[i][1] = 0;
            } else if (!all[i].a) {
                dp[i][0] = all[i].d;
                dp[i][1] = all[i].c;
            } else {
                dp[i][1] = (abs(all[i].a) / all[i].b + 1) * all[i].c;
                dp[i][0] = 0;
            }
        }
    }
    ll neg = 0, zero = 0, ans = 0;
    for (ll i = 0; i < n; ++i) {
        if (all[i].a < 0) {
            ++neg;
        } else if (!all[i].a) {
            ++zero;
            if (dp[i][0] > dp[i][1]) {
                ans += dp[i][1];
            } else {
                ans += dp[i][0];
                ++neg;
            }
        }
    }
    if (!(neg % 2)) {
        cout << ans;
        return 0;
    }
    ll res = INF;
    for (ll i = 0; i < n; ++i) {
        if (all[i].a < 0) {
            res = min(res, dp[i][1]);
        } else if (all[i].a > 0) {
            res = min(res, dp[i][0]);
        } else {
            if (dp[i][0] < dp[i][1]) {
                res = min(res, dp[i][1] - dp[i][0]);
            } else {
                res = min(res, dp[i][0] - dp[i][1]);
            }
        }
    }
    cout << res + ans;
}