#include <assert.h>

#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const char sep = ' ';

template <typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << sep;
    }
    return out;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<ll> arr(n);
    cin >> arr;
    for (auto& el : arr) {
        --el;
    }
    vector<vector<ll>> cost(m, vector<ll>(m));
    cin >> cost;
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        set<pair<ll, ll>> used;
        for (ll j = i + 1; j < n; ++j) {
            if (arr[i] > arr[j] && used.find({arr[i], arr[j]}) == used.end()) {
                ans += min(cost[arr[i]][arr[j]], cost[arr[j]][arr[i]]);
                used.insert({arr[i], arr[j]});
                used.insert({arr[j], arr[i]});
                arr[i] = arr[j];
            }
        }
    }
    cout << ans;
}