#include <bits/stdc++.h>
using namespace std;

#define in(a) a.begin(), a.end()
typedef long long ll;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

void read(int& x) {
	cin >> x;
}

template<typename T>
bool cmin(T& a, const T& b) {
	if (b < a) 
	{
		a = b;
		return true;
	}
	return false;
}

const ll oo = 1e15;

const int mxN = 1e5 + 500;
int n;
const int K = 3000;

vector<int> g[mxN];
int d[mxN];
ll sm[mxN], val[mxN];
int tim;
int tin[mxN], tout[mxN];

vector<int> ord;
int pos[mxN];

struct SparseTable {
	int sz;
	const int LOG = 17;
	vector<int> logs;
	vector<vector<int>> st;
	struct {
		bool operator()(const int& u, const int& v) const {
			return d[u] < d[v];
		}
	} MyCmp;
	void init(int num) {
		sz = num;
		logs.assign(sz + 1, 0);
		for (int i = 2; i <= sz; ++i) {
			logs[i] = logs[i >> 1] + 1;
		}
		st.assign(sz, vector<int>(LOG));
		for (int p = 0; p  < LOG; ++p) {
			for (int i = 0; i + (1 << p) <= sz; ++i) {
				st[i][p] = p == 0 ? ord[i] : min(st[i][p - 1], st[i + (1 << (p - 1))][p - 1], MyCmp);
			}
		}
	}
	int rmq(int l, int r) {
		int p = logs[r - l];
		return min(st[l][p], st[r - (1 << p)][p], MyCmp);
	}
} st;

int LCA(int u, int v) {
	int from = pos[u];
	int to = pos[v];
	if (to < from) swap(from, to);
	to += 1;
	return st.rmq(from, to);
}

void dfs(int v, int p = -1) {
	tin[v] = tim ++;
	pos[v] = ord.size();
	ord.push_back(v);
	for (int u :g[v]) {
		if (u == p) continue;
		d[u] = d[v] + 1;
		dfs(u, v);
		ord.push_back(v);
	}
	tout[v] = tim++;
}

bool is_u_child_of_v(int u, int v) {
	return tin[v] < tin[u] && tout[u] < tout[v];
}

ll ans;
void solve(int v, int p = - 1) {
	for (int u : g[v]) {
		if (u == p) continue;
		solve(u, v);
		sm[v] += sm[u];
	}
	ans = max(ans, (d[v] + 1) * (ll)sm[v]);
}

 main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n;
	for (int i = 0; i + 1 < n; ++i) {
		int u, v;
		cin >> u >> v, --u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	int q, t;
	cin >> q >> t;

	tim = 0;
	d[0] = 0;
	dfs(0);
	st.init(ord.size());

	fill(sm, sm + n, 0);
	fill(val, val + n, 0);
	ll prev_ans = 0;
	for (int qry = 0; qry < q; ++qry) {
		int k;
		cin >> k;
		vector<int> verts;
		for (int y = 0; y < k; ++y) {
			int v, c;
			cin >> v >> c;
			if (t == 1) {
				v -= 1;
			}
			if (t== 2) {
				v = (v + prev_ans) % (n - 1) + 1;
			}
			val[v] += c;
			sm[v] += c;
			verts.push_back(v);
		}
		
		ans = 0;
		if (k < K) 
		{
			sort(in(verts), [&](int i, int j) {
				return pos[i] < pos[j];
			});
			for (int i = 0; i + 1 < k; ++i) {
				verts.push_back(LCA(verts[i], verts[i + 1]));
			}
			// for (int i = 0; i < n; ++i) {
			// 	verts.push_back(i);
			// }
			sort(in(verts));
			verts.erase(unique(in(verts)), verts.end());
			
			k = verts.size();
			for (int i = 0; i < k; ++i) {
				for (int j = 0; j < k; ++j) {
					int u = verts[i];
					int v = verts[j];
					if (is_u_child_of_v(u, v)) {
						sm[v] += val[u];
					}
				}
			}
			
			for (int i = 0; i < n; ++i) {
				debug << sm[i] <<  ' ';
			}
			debug << endl;
			for (int v : verts) {
				ans = max(ans, (d[v] + 1) * sm[v]);
				sm[v] = val[v] = 0;
			}
		}
		else {
			solve(0);
			fill(sm, sm + n, 0);
			fill(val, val + n, 0);
		}
		prev_ans = ans;
		cout << ans << '\n';
	}

	return 0;
}