#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()

using pii = pair<int, int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;

const int N = 4e5 + 5;
const int K = 20;
int n, q, t, c[N], d[N], timer, tin[N], tout[N], p[N][K], last_ans, sum[N];
vec<int> g[N], G[N];
bool used[N];

void dfs(int v, int pr = 1) {
    if (v == 1) {
        d[v] = 1;
    } else {
        d[v] = d[pr] + 1;
    }
    tin[v] = ++timer;
    p[v][0] = pr;
    for (int k = 1; k < K; k++) {
        p[v][k] = p[p[v][k - 1]][k - 1];
    }

    for (int &u : g[v]) {
        if (u == pr) continue;
        dfs(u, v);
    }

    tout[v] = ++timer;
}

bool upper(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int LCA(int u, int v) {
    if (upper(u, v)) return u;
    if (upper(v, u)) return v;

    for (int k = K - 1; k >= 0; k--) {
        if (!upper(p[u][k], v)) {
            u = p[u][k];
        }
    }

    return p[u][0];
}

void sol(int v, int pr = -1) {
    sum[v] = 0;
    used[v] = true;
    if (c[v] != -1) {
        sum[v] = c[v];
    }

    sort(all(G[v]), [&](int u, int v) {
         return d[u] < d[v];
    });

    for (int &u : G[v]) {
        if (u == pr) continue;
        if (used[u]) continue;
        sol(u, v);
        sum[v] += sum[u];
    }

    last_ans = max(last_ans, sum[v] * d[v]);
}

void solve() {
    cin >> n;
    fill(c, c + n + 1, -1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;

        g[u].pb(v);
        g[v].pb(u);
    }

    dfs(1);

    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vec<int> verts;
        for (int i = 0; i < k; i++) {
            int v, C;
            cin >> v >> C;

            if (t == 2) {
                v = (v + last_ans) % (n - 1) + 2;
            }

            verts.pb(v);
            c[v] = C;
        }

        if (k == 1) {
            last_ans = c[verts[0]] * d[verts[0]];
            c[verts[0]] = -1;
            cout << last_ans << '\n';
            continue;
        }

        sort(all(verts), [&](int u, int v) {
             return tout[u] < tout[v];
        });

        int siz = sz(verts);
        for (int i = 1; i < siz; i++) {
            int L = LCA(verts[i - 1], verts[i]);
            if (L != verts[i - 1]) {
                G[L].pb(verts[i - 1]);
            }
            if (L != verts[i]) {
                G[L].pb(verts[i]);
            }
            if (verts.back() != L) {
                if (upper(verts.back(), L)) {
                    G[verts.back()].pb(L);
                }
                if (upper(L, verts.back())) {
                    G[L].pb(verts.back());
                }
            }
            verts.pb(L);
        }

        int L = LCA(verts[0], verts[siz - 1]);
        last_ans = 0;
        sol(L);

        for (int &v : verts) {
            G[v].clear();
            c[v] = -1;
            used[v] = false;
        }
        cout << last_ans << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}