#include <bits/stdc++.h>
#define allv(x) (x).begin(), (x).end()
using namespace std;
using ll = long long;

const ll MAXN = 4e5 + 20, INF = 1e18 + 9309706;

vector<ll> stck;
bool used[1010];
ll cost[1010][1010];
ll a[MAXN];
ll comp[1010];
ll dp[1010][1010];

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
inline int sz(T const& x) {
    return x.size();
}

vector<int> g[MAXN];
int tin[MAXN];
int tout[MAXN];
int h[MAXN];
vector<int> euler;
void dfs1(int v, int p) {
    h[v] = (p == -1 ? 0 : h[p] + 1);
    tin[v] = sz(euler);
    euler.push_back(v);
    for (int u : g[v]) {
        if (u == p) continue;
        dfs1(u, v);
        euler.push_back(v);
    }
    tout[v] = sz(euler);
}

struct Spt {
    pair<int, int> t[23][2 * MAXN];
    void build() {
        int n = sz(euler);
        for (int i = 0; i < n; i++) {
            t[0][i] = {-h[euler[i]], i};
            // cout << "t0 " << i << ' ' << t[0][i].first << ' ' << t[0][i].second << endl;
        }
        for (int d = 1; (1 << d) <= n; d++) {
            for (int i = 0; i + (1 << d) <= n; i++) {
                t[d][i] = max(t[d - 1][i], t[d - 1][i + (1 << d - 1)]);
            }
        }
    }
    int get(int l, int r) {
        int d = __lg(r - l);
        return max(t[d][l], t[d][r - (1 << d)]).second;
    }
} spt;
int lca(int u, int v) {
    if (tin[u] > tin[v]) swap(u, v);
    return euler[spt.get(tin[u], tin[v] + 1)];
}
bool is_pred(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}
int nxt(int u, int v) {
    assert(is_pred(u, v));
    assert(u != v);
    return euler[spt.get(tin[u], tin[v]) + 1];
}

vector<int> gg[MAXN];
ll cost_add[MAXN];

vector<int> condense(vector<int> v) {
    v.push_back(1);
    sort(allv(v), [](int a, int b) { return tin[a] < tin[b]; });
    int n1 = sz(v);
    for (int i = 0; i < n1 - 1; i++) {
        v.push_back(lca(v[i], v[i + 1]));
    }
    sort(allv(v), [](int a, int b) { return tin[a] < tin[b]; });
    v.resize(unique(allv(v)) - v.begin());
    int n2 = sz(v);
    vector<int> stck;
    stck.push_back(v[0]);
    for (int i = 1; i < n2; i++) {
        while (!is_pred(stck.back(), v[i])) {
            stck.pop_back();
        }
        gg[stck.back()].push_back(v[i]);
        gg[v[i]].push_back(stck.back());
        stck.push_back(v[i]);
    }
    return v;
}

pair<ll, ll> dfs2(int v, int p) {
    ll cntv = cost_add[v];
    ll ans = 0;
    for (int u : gg[v]) {
        if (u == p) continue;
        auto [cntu, cur] = dfs2(u, v);
        cntv += cntu;
        smax(ans, cur);
    }
    smax(ans, (h[v] + 1) * cntv);
    return {cntv, ans};
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs1(1, -1);
    spt.build();
    ll last_ans = 0;
    int qcnt, is_cringe;
    cin >> qcnt >> is_cringe;
    while (qcnt--) {
        int k;
        cin >> k;
        vector<int> vec(k);
        for (int i = 0; i < k; i++) {
            cin >> vec[i];
            if (is_cringe == 2) {
                vec[i] = (vec[i] + last_ans) % (n - 1) + 2;
            }
            cin >> cost_add[vec[i]];
        }
        vec = condense(vec);
        last_ans = dfs2(1, -1).second;
        cout << last_ans << '\n';
        for (int v : vec) {
            gg[v].clear();
            cost_add[v] = 0;
        }
    }
    return 0;
}