#include <iostream>
#include <vector>

using namespace std;


#define int long long

typedef pair<int, int> pii;

pii cost(int x, int delta, int up, int down) {
    int cost_neg, cost_pos;
    if (x < 0) {
        cost_neg = 0;
        cost_pos = up * ((abs(x) + delta) / delta);
    }
    else if (x > 0) {
        cost_pos = 0;
        cost_neg = down * ((x + delta) / delta);
    }
    else {
        cost_pos = up;
        cost_neg = down;
    }
    return {cost_neg, cost_pos };
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int& i : a)
        cin >> i;
    for (int& i : b)
        cin >> i;
    for (int& i : c)
        cin >> i;
    for (int& i : d)
        cin >> i;
    vector<pii> dp(n);
    dp[0] = cost(a[0], b[0], c[0], d[0]);
    for (int i = 1; i < n; i++) {
        pii costs = cost(a[i], b[i], c[i], d[i]);
        dp[i].first = min(costs.first + dp[i - 1].second, costs.second + dp[i - 1].first);
        dp[i].second = min(costs.first + dp[i - 1].first, costs.second + dp[i - 1].second);
    }
    cout << dp.back().second;
}

signed main() {
    solve();
}