#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>


using namespace std;


#define int long long
#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

typedef pair<int, int> pii;

vector<int> par;

int get_par(int v) {
    if (par[v] != v)
        par[v] = get_par(par[v]);
    return par[v];
}

void merge(int a, int b) {
    a = get_par(a);
    b = get_par(b);
    par[a] = b;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> arr(n), last(m);
    vector<int> cnt(m);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        arr[i]--;
        cnt[arr[i]]++;
        last[arr[i]] = i;
    }

    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < m; j++)
            cin >> cost[i][j];
    par.resize(m);
    iota(walk(par), 0);
    int end_pos = 0, start_pos = 0;
    for (int i = 0; i < n; i++) {
        if (end_pos < i) {
            start_pos = i;
            end_pos = last[arr[i]];
        }
        else {
            end_pos = max(last[arr[i]], end_pos);
            merge(arr[i], arr[start_pos]);
        }
    }
    vector<vector<int>> groups;
    int prev_ = -1;
    for (int i = 0; i < n; i++) {
        if (get_par(arr[i]) != prev_) {
            prev_ = get_par(arr[i]);
            groups.push_back(vector<int> {arr[i]});
        }
        else
            groups.back().push_back(arr[i]);
    }
    vector<vector<int>> summed_cost(sz(groups), vector<int>(m));
    for (int t = 0; t < sz(groups); t++) {
        auto& u = groups[t];
        sort(walk(u));
        u.erase(unique(walk(u)), u.end());
        for (int i : u) {
            for (int j = 0; j < m; j++)
                summed_cost[t][j] += cnt[i] * cost[i][j];
        }
    }
    vector<vector<int>> dp(sz(groups), vector<int>(m));
    dp[0][0] = summed_cost[0][0];
    for (int i = 1; i < m; i++) 
        dp[0][i] = min(dp[0][i - 1], summed_cost[0][i]);
        
    for (int i = 1; i < sz(groups); i++) {
        dp[i][0] = dp[i - 1][0] + summed_cost[i][0];
        for (int j = 1; j < m; j++)
            dp[i][j] = min(dp[i][j - 1], dp[i - 1][j] + summed_cost[i][j]);
    }
    cout << dp.back().back();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr)->sync_with_stdio(false);
    solve();
}