#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;


bool is_prime(ll n) {
    if (n == 1) return true;
    for (ll d = 2; d * d <= n; d++) {
        if (n % d == 0) {
            return false;
        }
    }
    return true;
}

ll find(ll sum) {
    for (ll has = sum; has >= 1; has--) {
        if (is_prime(has)) {
            return has;
        }
    }
}

void solve() {
    ll n; cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<ll> dif = {0};
    for (int i = 0; i < n - 1; i++) {
        dif.push_back(-(a[i + 1] + a[i]));
    }
    ll sz = dif.size();
    vector<vector<ll>> dp(sz, vector<ll> (sz, INF));
    dp[0][0] = 0;
    for (int i = 1; i < sz; i++) {
        if (dif[i] < 0) break;
        dp[i][0] = 0;
    }
    for (int i = 1; i < sz; i++) {
        for (int k = 1; k < sz; k++) {
            ll cost = 0, prev = 0;
            for (int j = i; j >= 1; j--) {
                if (dif[j] < 0) break;
                ll nw = max(0ll, (dif[j] + 1) - prev);
                cost += nw;
                prev = nw;
                if (k - (i - j + 1) < 0) {
                    break;
                }
                // cout << i << " " << k << " -> " << j - 1 << " - " << k - (i - j + 1) << '\n';
                dp[i][k] = min(dp[i][k], dp[j - 1][k - (i - j + 1)] + cost);
            }
            if (dif[i] < 0) {
                dp[i][k] = min(dp[i][k], dp[i - 1][k - 1]);
            } else {
                dp[i][k] = min(dp[i][k], dp[i - 1][k]);
            }
        }
    }
    ll ans = INF;
    for (int j = 0; j < sz; j++) {
        ans = min(ans, dp[sz - 1][sz - j - 1]);
        cout << ans << " ";
    }
    cout << '\n';
}
                
signed main() {

                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}