#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;


bool is_prime(ll n) {
    if (n == 1) return true;
    for (ll d = 2; d * d <= n; d++) {
        if (n % d == 0) {
            return false;
        }
    }
    return true;
}

ll find(ll sum) {
    for (ll has = sum; has >= 1; has--) {
        if (is_prime(has)) {
            return has;
        }
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> a(n + 1);
    vector<ll> segl(m + 1, INF), segr(m + 1, -INF);
    for (ll i = 1; i <= n; i++) {
        cin >> a[i];
        segl[a[i]] = min(segl[a[i]], i);
        segr[a[i]] = max(segr[a[i]], i);
    }
    vector<vector<ll>> cost(m + 1, vector<ll> (m + 1));
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> cost[i][j];
        }
    }
    // vector<vector<ll>> pref(m + 1, vector<ll> (m + 1));
    // for (int i = 1; i <= m; i++) {
    //     for (int j = 1; j <= m; j++) {
    //         pref[i][j] = pref[i - 1][j] + cost[i][j];
    //     }
    // }
    vector<pair<ll, ll>> event;
    for (int i = 1; i <= m; i++) {
        if (segl[i] != INF) {
            event.push_back({segl[i], 1});
            event.push_back({segr[i], -1});
        }
    }
    sort(event.begin(), event.end());
    vector<pair<ll, ll>> group;
    ll bal = 0, start = 0;
    for (int i = 0; i < event.size(); i++) {
        if (bal == 0) {
            start = event[i].first;
        }
        bal += event[i].second;
        if (bal == 0) {
            group.push_back({start, event[i].first});
        }
    }
    ll sz = group.size();

    vector<vector<ll>> col(sz);
    vector<bool> used(m + 1, false);
    for (int i = 0; i < sz; i++) {
        for (int c = group[i].first; c <= group[i].second; c++) {
            if (!used[a[c]]) {
                col[i].push_back(a[c]);
            }
            used[a[c]] = true;
        }
    }

    vector<vector<ll>> prec(sz, vector<ll> (m + 1, 0));
    for (int i = 0; i < sz; i++) {
        for (int j = 1; j <= m; j++) {
            for (auto c : col[i]) {
                prec[i][j] += cost[c][j];
            }
        }
    }


    vector<ll> dp(m + 1, 0), pref(m + 1, 0);
    for (int i = 0; i < sz; i++) {
        vector<ll> nxtdp(m + 1, INF), nxtpref(m + 1, INF);
        for (int j = 1; j <= m; j++) {
            nxtdp[j] = pref[j] + prec[i][j];
            nxtpref[j] = min(nxtpref[j - 1], nxtdp[j]);
        }
        swap(dp, nxtdp);
        swap(pref, nxtpref);
    }
    ll ans = INF;
    for (int j = 1; j <= m; j++) {
        ans = min(ans, dp[j]);
    }
    cout << ans << '\n';
}
                
signed main() {
                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}