#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;

void precalc(ll v, vector<ll>& dep, vector<ll>& p, vector<vector<ll>>& g, ll pp = -1) {
    for (auto to : g[v]) {
        if (to == pp) continue;
        dep[to] = dep[v] + 1;
        p[to] = v;
        precalc(to, dep, p, g, v);
    }
}

void solve() {
    ll n; cin >> n;
    vector<vector<ll>> g(n);
    for (int i = 0; i < n - 1; i++) {
        ll u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<ll> dep(n, 0), p(n, 0);
    precalc(0, dep, p, g);
    vector<ll> dp(n, 0);

    ll q, t; cin >> q >> t;
    while (q--) {
        dp.assign(n, 0);
        ll k; cin >> k;
        vector<pair<ll, ll>> a(k);
        for (int i = 0; i < k; i++) {
            cin >> a[i].first >> a[i].second;
            a[i].first--;
        }

        for (int i = 0; i < k; i++) {
            ll v = a[i].first;
            while (true) {
                dp[v] += (dep[v] + 1) * a[i].second;
                if (v == 0) break;
                v = p[v];
            }
        }

        ll ans = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, dp[i]);
        }
        cout << ans << '\n';

        
    }
}
                
signed main() {

                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}