#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <iomanip>
#include <cstdio>
#include <cmath>
using namespace std;
using ll = long long;
const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<vector<int>> ind(m + 1);
    vector<int> right(m + 1);
    set<int> ost;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ind[a[i]].push_back(i);
        ost.insert(i);
        right[a[i]] = i;
    }
    vector<vector<ll>> cost(m + 1, vector<ll>(m + 1));
    for (int i = 1; i <= m; ++i) {
        for (int j = 1; j <= m; ++j)
            cin >> cost[i][j];
    }
    int c = 0;
    vector<int> l_block, r_block;
    vector<vector<int>> col;
    while (!ost.empty()) {
        int i = *ost.begin();
        l_block.push_back(i);
        col.emplace_back();
        col.back().push_back(a[i]);
        for (int j : ind[a[i]]) {
            ost.erase(j);
        }
        int r = right[a[i]];
        while (!ost.empty() && *ost.begin() <= r) {
            i = *ost.begin();
            col.back().push_back(a[i]);
            for (int j : ind[a[i]]) {
                ost.erase(j);
            }
            r = max(r, right[a[i]]);
        }
        r_block.push_back(r);
        c++;
    }
    int cnt_blocks = c;
    vector<vector<ll>> cost_blocks(cnt_blocks, vector<ll>(m + 1));
    for (int i = 0; i < cnt_blocks; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int z : col[i]) {
                cost_blocks[i][j] += cost[z][j];
            }
        }
    }
    vector<vector<ll>> dp(cnt_blocks + 1, vector<ll>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 1; i <= cnt_blocks; ++i) {
        vector<ll> min_dp(m + 1, INF);
        if (i == 1) min_dp[0] = 0;
        for (int j = 1; j <= m; ++j) {
            min_dp[j] = min(min_dp[j - 1], dp[i - 1][j]);
        }
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = min_dp[j] + cost_blocks[i - 1][j];
        }
    }
    ll ans = INF;
    for (int j = 1; j <= m; ++j)
        ans = min(ans, dp[cnt_blocks][j]);
    cout << ans;

    return 0;
}