#include <iostream>
#include <vector>
#include <algorithm>
#include <string.h>
#include <fstream>
#include <numeric>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

void dfs(int v, vector<int>& p, vector<int>& h, vector<vector<int>>& g) {
	for (int to : g[v]) {
		if (p[to] == -1) {
			p[to] = v;
			h[to] = h[v] + 1;
			dfs(to, p, h, g);
		}
	}

}

int main() {
	int n;
	cin >> n;

	vector<vector<int>> g(n);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		u--; v--;

		g[u].push_back(v);
		g[v].push_back(u);
	}

	vector<int> p(n, -1), h(n);
	p[0] = 0;

	dfs(0, p, h, g);

	int q, t;
	cin >> q >> t;

	for (int i = 0; i < q; ++i) {
		int k;
		cin >> k;

		vector<ll> money(n);

		for (int i = 0; i < k; ++i) {
			int v; ll c;
			cin >> v >> c;
			v--;

			while (v != 0) {
				money[v] += (h[v] + 1) * c;
				v = p[v];
			}

			money[0] += c;
		}

		cout << *max_element(money.begin(), money.end()) << "\n";
	}
}