#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <chrono>
#include <ctime>
#include <random>
#include <unordered_map>
#include <unordered_set>
#define endl '\n'

typedef long long i64;
typedef long double ld;

const i64 INF = 1e18;

using namespace std;

mt19937 rnd(777);

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

i64 lcm(i64 a, i64 b) {
	return a * b / gcd(a, b);
}

const i64 S = 5e5 + 10, K = 1005;
i64 a[S], matr[K][K], fr[K], lst[K], c[K], cnt[K], done[K];
vector <i64> p[K], rev[K], pc[K], pokr[K], p1[K];

i64 used[K];
vector <i64> topsort;

void dfs(i64 v) {
	used[v] = 1;
	for (auto x : p[v]) {
		if (!used[x]) dfs(x);
	}
	topsort.push_back(v);
}

void dfsRev(i64 v, i64 clr) {
	used[v] = 1; c[v] = clr;
	pokr[clr].push_back(v);
	for (auto x : rev[v]) {
		if (!used[x]) dfsRev(x, clr);
	}
}

i64 dp[K][K], pref[K][K], took[K];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	i64 n, m; cin >> n >> m;

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
		if (fr[a[x]] == 0) fr[a[x]] = x;
		lst[a[x]] = x;
	}

	for (i64 x = 1; x <= m; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			dp[x][y] = INF; pref[x][y] = INF;
			cin >> matr[x][y];
		}
	}

	for (i64 x = 1; x <= m; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			if (x == y || lst[y] == 0 || lst[x] == 0) continue;
			if (lst[y] < fr[x]) {
				p[x].push_back(y);
				rev[y].push_back(x);
			}
			else if (lst[y] > fr[x] && lst[y] < lst[x]) {
				p[x].push_back(y); rev[y].push_back(x);
				p[y].push_back(x); rev[x].push_back(y);
			}
		}
	}

	for (i64 x = 1; x <= m; ++x) {
		if (!used[x]) dfs(x);
	}

	reverse(topsort.begin(), topsort.end());
	fill(used, used + K, 0);

	i64 color = 0;

	for (auto x : topsort) {
		if (!used[x]) {
			++color;
			dfsRev(x, color);
		}
	}

	for (i64 x = 1; x <= color; ++x) {
		for (auto y : pokr[x]) {
			for (auto t : p[y]) {
				if (c[t] != c[y]) {
					p1[c[y]].push_back(c[t]);
				}
			}
		}
	}

	for (i64 d = topsort.size() - 1; d >= 0; --d) {
		i64 x = topsort[d];
		i64 clr = c[x];
		if (cnt[clr]) continue;
		took[clr] = 1;
		for (i64 y = 1; y <= m; ++y) {
			i64 cost = 0;
			for (auto nd : pokr[clr]) {
				if (!done[nd]) {
					done[nd] = 1;
					cost += matr[nd][y];
				}
			}
			for (auto nd : pokr[clr]) {
				done[nd] = 0;
			}
			dp[clr][y] = cost;
			for (auto t : p1[clr]) {
				if (!took[t] && cnt[t] && t != clr) {
					dp[clr][y] += pref[t][y];
				}
			}
		}
		for (auto t : p1[clr]) took[t] = 0;
		for (i64 y = 1; y <= m; ++y) {
			if (y == 1) pref[clr][y] = dp[clr][y];
			else pref[clr][y] = min(pref[clr][y - 1], dp[clr][y]);
		}
		cnt[clr] = 1;
	}

	i64 ans = 0;

	for (i64 x = 1; x <= color; ++x) {
		if (took[x]) {
			i64 f = INF;
			for (i64 y = 1; y <= m; ++y) {
				f = min(f, dp[x][y]);
			}
			ans += f;
		}
	}

	cout << ans;
} 