#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;
using ui128 =__uint128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


array<int, 2> t[1 << 19];
int lz[1 << 19];
int cur_rev[1 << 19];
array<int, 2> merge(array<int, 2> a, array<int, 2> b) {
    return {a[0] ^ b[0], a[1] ^ b[1]};
}

void push(int x, int l, int r) {
    if (!lz[x]) return;

    if (l + 1 != r) {
        lz[2 * x + 1] ^= lz[x];
        lz[2 * x + 2] ^= lz[x];
    } else {
        cur_rev[x] ^= lz[x];
    }

    swap(t[x][0], t[x][1]);
    lz[x] = 0;
}

int get(int i, int x, int l, int r) {
    push(x, l, r);
    if (l + 1 == r) {
        int res = cur_rev[x];
        cur_rev[x] = 0;
        return res;
    }
    
    int m = (l + r) / 2;
    if (i < m) {
        return get(i, 2 * x + 1, l, m);
    } else {
        return get(i, 2 * x + 2, m, r);
    }
}

array<int, 2> get(int lq, int rq, int x, int l, int r) {
    push(x, l, r);
    if (rq <= l || r <= lq) return {0, 0};
    if (lq <= l && r <= rq) return t[x];

    int m = (l + r) / 2;
    auto a = get(lq, rq, 2 * x + 1, l, m);
    auto b = get(lq, rq, 2 * x + 2, m, r);
    return merge(a, b);
}

void update(int lq, int rq, int x, int l, int r) {
    if (lq >= rq) return;
    push(x, l, r);
    if (rq <= l || r <= lq) return;
    if (lq <= l && r <= rq) {
        lz[x] = 1;
        push(x, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(lq, rq, 2 * x + 1, l, m);
    update(lq, rq, 2 * x + 2, m, r);
    t[x] = merge(t[2 * x + 1], t[2 * x + 2]);
}

void update(int i, array<int, 2> v, int x, int l, int r) {
    push(x, l, r);
    if (l + 1 == r) {
        t[x] = v;
        return;
    }

    int m = (l + r) / 2;
    if (i < m) {
        update(i, v, 2 * x + 1, l, m);
        push(2 * x + 2, m, r);
    } else {
        push(2 * x + 1, l, m);
        update(i, v, 2 * x + 2, m, r);
    }
    t[x] = merge(t[2 * x + 1], t[2 * x + 2]);
}

int bin(string s) {
    int res = 0;
    for (int i = 0; i < s.size(); i++) {
        res = 2 * res + s[i] - '0';
    }
    return res;
}

void change(char& x) {
    if (x == '1') {
        x = '0';
    } else {
        x = '1';
    }
}

string rev(string s) {
    for (auto& el : s) change(el);
    return s;
}

int res[1 << 18];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<string> rev_a = a;
    for (auto& el : rev_a) el = rev(el);
    
    for (int i = 1; i < (1 << 18); i++) {
        vector<int> used(3, 0);
        used[res[i - 1]] = 1;
        if (i % 2 == 1) {
            used[res[i / 2]] = 1;
        }
        while (used[res[i]]) res[i]++;
    }

    vector<int> pref(n);
    for (int i = 0; i + 1 < n; i++) pref[i + 1] = pref[i] + a[i].length();

    auto print_answer = [&]() {
        if (get(0, n, 0, 0, n)[0]) {
            cout << "First\n";
        } else {
            cout << "Second\n";
        }
    };

    for (int i = 0; i < n; i++) update(i, {res[bin(a[i])], res[bin(rev_a[i])]}, 0, 0, n);
    print_answer();
    for (int query_id = 0; query_id < q; query_id++) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        int lq = upper_bound(all(pref), l) - pref.begin() - 1;
        int rq = upper_bound(all(pref), r) - pref.begin() - 1;
        update(lq + 1, rq - 1 + 1, 0, 0, n);
        if (lq == rq) {
            if (get(lq, 0, 0, n)) swap(a[lq], rev_a[lq]);
            for (int i = l - pref[lq]; i <= r - pref[lq]; i++) change(a[lq][i]), change(rev_a[lq][i]);
            update(lq, {res[bin(a[lq])], res[bin(rev_a[lq])]}, 0, 0, n);
        } else {
            if (get(lq, 0, 0, n)) swap(a[lq], rev_a[lq]);
            if (get(rq, 0, 0, n)) swap(a[rq], rev_a[rq]);
            for (int i = l - pref[lq]; i < a[lq].length(); i++) change(a[lq][i]), change(rev_a[lq][i]);
            for (int i = 0; i <= r - pref[rq]; i++) change(a[rq][i]), change(rev_a[rq][i]);
            update(lq, {res[bin(a[lq])], res[bin(rev_a[lq])]}, 0, 0, n);
            update(rq, {res[bin(a[rq])], res[bin(rev_a[rq])]}, 0, 0, n);
        }
        
        print_answer();
    } 

    return 0;
}