#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int mod = 1e9 + 7;
const int MAX = 4e5 + 7;
#define int long long


vector<int> g[MAX];
int tin[MAX], tout[MAX], timer = 0, up[MAX][20], d[MAX];

void dfs(int v, int p) {
    tin[v] = ++timer;
    up[v][0] = p;
    for (int i = 1; i < 20; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to : g[v]) {
        if (to != p) {
            d[to] = d[v] + 1;
            dfs(to, v);
        }
    }
    tout[v] = ++timer;
}

bool good(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (good(a, b)) return a;
    if (good(b, a)) return b;
    for (int i = 18; i >= 0; i--) {
        if (!good(up[a][i], b)) a = up[a][i];
    }
    return up[a][0];
}

int n;

void solve() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    d[1] = 0;
    dfs(1, 1);
    int last = 0;
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<pair<int, int>> st;
        for (int i = 1; i <= k; i++) {
            int x, y;
            cin >> x >> y;
            if (t == 2) {
                x = (x + last) % (n - 1) + 2;
            }
            st.push_back({x, y});
        }
        sort(st.begin(), st.end(), [&](auto p1, auto p2) {
            return tin[p1.first] < tin[p2.first];
        });
        vector<int> nxt(k + 1, k + 1);
        vector<int> pref(k + 1, 0);
        st.insert(st.begin(), {-1, -1});
        for (int i = 1; i <= k; i++) {
            pref[i] = pref[i - 1] + st[i].second;
        }
        for (int i = 1; i <= k; i++) {
            int l = i, r = k;
            while (l < r) {
                int mid = (l + r) / 2;
                if (good(st[i].first, st[mid].first)) {
                    l = mid + 1;
                } else {
                    r = mid;
                }
            }
            if (good(st[i].first, st[l].first)) l++;
            nxt[i] = l;
        }
        ll res = 0;
        map<int, int> mp;
        for (int i = 1; i <= k; i++) {
            int r = i;
            while (r <= k) {
                r = max(r, nxt[i] - 1);
                int lc = lca(st[i].first, st[r].first);
                for (int bt = 18; bt >= 0; bt--) {
                    if (r + (1 << bt) <= k) {
                        if (good(lc, st[r + (1 << bt)].first)) {
                            r += (1 << bt);
                        }
                    }
                }
                int sum = pref[r] - pref[i - 1];
                res = max(res, d[lc] * sum + sum);
                if (mp[lc]) break;
                mp[lc] = true;
                r++;
            }
        }
        cout << res << '\n';
        last = res;
    }
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}