#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <numeric>
#include <random>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

bool is_prime(int x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

void solve() {
    const int MAX = 1e5 + 50;
    vector <bool> is_pr(MAX, true);
    for (int i = 2; i < MAX; i++) {
        if (!is_pr[i]) continue;
        for (int j = i * i; j < MAX; j += i) {
            is_pr[j] = false;
        }
    }
    
    int n, m;
    cin >> n >> m;
    
    int suma = n * (n + 1) / 2;
    
    vector <int> ans;
    vector <bool> used(n + 1, false);
    vector <int> ord(n);
    iota(all(ord), 1);
    mt19937 rnd(4218);
    shuffle(all(ord), rnd);
//    reverse(all(ord));
    int cnt = 0;
    for (int i : ord) {
        if (is_prime(suma) || cnt == m - 1) break;
        if (used[i] || !is_pr[i]) continue;
        suma -= i;
        ans.push_back(i);
        used[i] = true;
        cnt++;
    }
    cout << (int)ans.size() + 1 << "\n";
    for (int i : ans) {
        cout << 1 << "\n";
        cout << i << "\n";
    }
    cout << n - (int)ans.size() << "\n";
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            cout << i << " ";
        }
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}