#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <numeric>
#include <random>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;
    
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    
    int m = n - 1;
    
    vector <int> b(m, 0);
    for (int i = 0; i < m; i++) {
        int s = a[i] + a[i + 1];
        if (s <= 0) {
            b[i] = -s + 1;
        }
    }
    
    vector <vector <int>> dp(m + 1, vector <int> (m + 1, INF));
    dp[0][0] = 0;
    for (int i = 1; i <= m; i++) {
        dp[i][0] = 0;
        for (int j = 1; j <= i; j++) {
            dp[i][j] = dp[i - 1][j];
            int added = 0;
            int cur = 0;
            for (int k = 1; k <= j; k++) {
                if (added >= b[i - k]) {
                    added = 0;
                    dp[i][j] = min(dp[i][j], cur + dp[i - k][j - k]);
                } else {
                    int need = b[i - k] - added;
                    cur += need;
                    added = need;
                    dp[i][j] = min(dp[i][j], cur + dp[i - k][j - k]);
                }
            }
        }
    }
    
    for (int k = m; k >= 0; k--) {
        cout << dp[m][k] << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}