#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <numeric>
#include <random>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

const int B = 320;

struct SqrtComp {
    int mx, n;
    vector <int> a;
    vector <int> b;
    vector <int> p;
    vector <bool> clear;
    
    SqrtComp(int _n) : n(_n) {
        a.assign(n, 0);
        b.assign(n, 0);
        p.assign(n, 0);
        clear.assign(n, false);
        mx = 0;
    }
    
    void add(int l, int r, int c) {
        if (l / B == r / B) {
            int st = l / B * B;
            if (clear[l / B]) {
                p[l / B] = 0;
                for (int i = st; i < min(n, st + B); i++) {
                    a[i] = 0;
                }
            }
            for (int i = l; i <= r; i++) {
                a[i] += c * (i - l + 1);
                mx = max(mx, a[i] + p[l / B] * (i - st + 1));
            }
        } else {
            {
                int st = l / B * B;
                if (clear[l / B]) {
                    p[l / B] = 0;
                    for (int i = st; i < min(n, st + B); i++) {
                        a[i] = 0;
                    }
                }
                for (int i = l; i < min(n, st + B); i++) {
                    a[i] += c * (i - l + 1);
                    mx = max(mx, a[i] + p[l / B] * (i - st + 1));
                }
            }
            {
                int st = r / B * B;
                if (clear[r / B]) {
                    p[r / B] = 0;
                    for (int i = st; i < min(n, st + B); i++) {
                        a[i] = 0;
                    }
                }
                for (int i = st; i <= r; i++) {
                    a[i] += c * (i - st + 1);
                    mx = max(mx, a[i] + p[r / B] * (i - st + 1));
                }
            }
            int lb = l / B;
            int rb = r / B;
            if (lb + 1 <= rb - 1) {
                int stl = l / B * B;
                int endl = stl + B - 1;
                int cur = endl - l;
            }
        }
    }
};

vector <int> pr;
vector <int> d;
vector <vector <int>> gr;

void dfs(int v, int p) {
    for (int u : gr[v]) {
        if (u == p) continue;
        pr[u] = v;
        d[u] = d[v] + 1;
        dfs(u, v);
    }
}

void solve() {
    int n;
    cin >> n;
    
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    
    pr.resize(n);
    d.resize(n);
    
    d[0] = 1;
    pr[0] = -1;
    
    dfs(0, 0);
    
    int q, t;
    cin >> q >> t;
    int last_ans = 0;
    while (q--) {
        int k;
        cin >> k;
        
        int ans = 0;
        vector <int> res(n, 0);
        for (int i = 0; i < k; i++) {
            int v, c;
            cin >> v >> c;
            if (t == 1) {
                v--;
                while (v != -1) {
                    res[v] += c * d[v];
                    ans = max(ans, res[v]);
                    v = pr[v];
                }
            } else {
                v = (v + last_ans) % (n - 1) + 1;
                while (v != -1) {
                    res[v] += c * d[v];
                    ans = max(ans, res[v]);
                    v = pr[v];
                }
            }
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}