#include "bits/stdc++.h"
using namespace std;
using ll = long long;

random_device rd;
mt19937 rng(rd());
int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

struct segtree {
    vector<int> tree;
    int size;
    int neutral_element = 0;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, neutral_element);
    }

    void build(const vector<int> &a) {
        size = 1;
        while (size < a.size()) size *= 2;
        tree.assign(2 * size, neutral_element);
        for (int i = size; i < size + a.size(); i++) tree[i] = a[i - size];
        for (int i = size - 1; i > 0; i--) tree[i] = merge(tree[i << 1], tree[i << 1 | 1]);
    }

    int merge(int a, int b) {
        return a + b;
    }

    void upd(int pos, int val) {
        pos += size;
        tree[pos] = merge(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = merge(tree[pos], tree[pos ^ 1]);
    }

    int get(int l, int r) {
        if (l > r) return neutral_element;
        int ans = neutral_element;
        for (l += size, r += size + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans = merge(ans, tree[l++]);
            if (r & 1) ans = merge(ans, tree[--r]);
        }
        return ans;
    }
};

void solve() {
    ll a, b, n, m;
    cin >> a >> b >> n >> m;
    if (2 * a == b) {
        if (n * 2 == m) cout << n << " 0";
        else cout << -1;
        return;
    }
    ll x = (2 * n - m) / (2 * a - b);
    if (2 * n - 2 * a * x == m - b * x and x >= 0 and n - a * x >= 0) cout << n - a * x << ' ' << x;
    else cout << -1;
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);

    int queries = 1;
#ifdef sunnatov
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> queries;
#else
    // cin >> queries;
#endif

    for (int test_case = 1; test_case <= queries; test_case++) {
#ifdef sunnatov
        cout << "Test case: " << test_case << endl;
#endif
        solve();
        cout << '\n';
    }
}