#include "bits/stdc++.h"
using namespace std;
using ll = long long;
const ll inf = 1e18;

random_device rd;
mt19937 rng(rd());
int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}


struct segtree {
    vector<int> tree;
    int size;
    int neutral_element = 0;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, neutral_element);
    }

    void build(const vector<int> &a) {
        size = 1;
        while (size < a.size()) size *= 2;
        tree.assign(2 * size, neutral_element);
        for (int i = size; i < size + a.size(); i++) tree[i] = a[i - size];
        for (int i = size - 1; i > 0; i--) tree[i] = merge(tree[i << 1], tree[i << 1 | 1]);
    }

    int merge(int a, int b) {
        return a + b;
    }

    void upd(int pos, int val) {
        pos += size;
        tree[pos] = merge(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = merge(tree[pos], tree[pos ^ 1]);
    }

    int get(int l, int r) {
        if (l > r) return neutral_element;
        int ans = neutral_element;
        for (l += size, r += size + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans = merge(ans, tree[l++]);
            if (r & 1) ans = merge(ans, tree[--r]);
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int &x: a) cin >> x;
    for (int &x: b) cin >> x;
    for (int &x: c) cin >> x;
    for (int &x: d) cin >> x;
    int positive = 0, negative = 0, zero = 0;
    for (int x: a) {
        if (x == 0) zero++;
        else if (x > 0) positive++;
        else negative++;
    }
    ll change = inf, now = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] > 0) {
            change = min(change, 1ll * (a[i] / b[i] + 1) * d[i]);
        } else if (a[i] < 0) {
            change = min(change, 1ll * (abs(a[i]) / b[i] + 1) * c[i]);
        }
    }
    if (zero == 0) {
        if (negative % 2 == 0) cout << 0;
        else cout << change;
        return;
    }
    ll ans = inf;
    vector<int> vec;
    for (int i = 0; i < n; i++) {
        if (a[i] != 0) continue;
        now += c[i];
        vec.emplace_back(-c[i] + d[i]);
    }
    positive += zero;
    ans = min(ans, now + (negative % 2 ? change : 0ll));
    sort(vec.begin(), vec.end());
    for (int x: vec) {
        positive--, negative++;
        now += x;
        ans = min(ans, now + (negative % 2 ? change : 0ll));
    }
    cout << ans;
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);

    int queries = 1;
#ifdef sunnatov
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> queries;
#else
    // cin >> queries;
#endif

    for (int test_case = 1; test_case <= queries; test_case++) {
#ifdef sunnatov
        cout << "Test case: " << test_case << endl;
#endif
        solve();
        cout << '\n';
    }
}