#include "bits/stdc++.h"
using namespace std;
using ll = long long;
const ll inf = 1e18;

random_device rd;
mt19937 rng(rd());
int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}


struct segtree {
    vector<int> tree;
    int size;
    int neutral_element = 0;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, neutral_element);
    }

    void build(const vector<int> &a) {
        size = 1;
        while (size < a.size()) size *= 2;
        tree.assign(2 * size, neutral_element);
        for (int i = size; i < size + a.size(); i++) tree[i] = a[i - size];
        for (int i = size - 1; i > 0; i--) tree[i] = merge(tree[i << 1], tree[i << 1 | 1]);
    }

    int merge(int a, int b) {
        return a + b;
    }

    void upd(int pos, int val) {
        pos += size;
        tree[pos] = merge(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = merge(tree[pos], tree[pos ^ 1]);
    }

    int get(int l, int r) {
        if (l > r) return neutral_element;
        int ans = neutral_element;
        for (l += size, r += size + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans = merge(ans, tree[l++]);
            if (r & 1) ans = merge(ans, tree[--r]);
        }
        return ans;
    }
};

const int N = 1e5 + 5;
vector<bool> ok(N, true);
vector<ll> all;

void init() {
    for (int i = 2; i * i < N; i++) {
        if (!ok[i]) continue;
        for (int j = i * i; j < N; j += i) ok[j] = false;
    }
}
bool check(ll n) {
    int i = lower_bound(all.begin(), all.end(), n) - all.begin();
    return i < all.size() and all[i] == n;
}

ll get(ll l, ll r) {
    return (r - l + 1) * (l + r) / 2;
}

void solve() {
    int n = 1e5;
    ll sum = get(1, n);
    for (int i = 1; i <= n; i++) {
        if (!ok[i]) continue;
        for (ll j = 1; j * j * i <= sum; j++) all.emplace_back(j * j * i);
    }
    sort(all.begin(), all.end());


    int m;
    cin >> n >> m;
    vector<vector<int>> ans;
    while (n >= 1) {
        int old = n;
        for (int i = 1; i <= n; i++) {
            if (check(get(i, n))) {
                vector<int> v;
                for (int j = i; j <= n; j++) v.emplace_back(j);
                ans.emplace_back(v);
                n = i - 1;
                break;
            }
        }
        assert(old != n);
    }
    cout << ans.size() << '\n';
    for (auto v: ans) {
        cout << v.size() << '\n';
        for (int x: v) cout << x << ' ';
        cout << '\n';
    }
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);

    int queries = 1;
#ifdef sunnatov
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> queries;
#else
    // cin >> queries;
#endif

    init();

    for (int test_case = 1; test_case <= queries; test_case++) {
#ifdef sunnatov
        cout << "Test case: " << test_case << endl;
#endif
        solve();
        cout << '\n';
    }
}