#include "bits/stdc++.h"
using namespace std;
using ll = long long;
const ll inf = 1e18;

random_device rd;
mt19937 rng(rd());
int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}


struct segtree {
    vector<int> tree;
    int size;
    int neutral_element = 0;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, neutral_element);
    }

    void build(const vector<int> &a) {
        size = 1;
        while (size < a.size()) size *= 2;
        tree.assign(2 * size, neutral_element);
        for (int i = size; i < size + a.size(); i++) tree[i] = a[i - size];
        for (int i = size - 1; i > 0; i--) tree[i] = merge(tree[i << 1], tree[i << 1 | 1]);
    }

    int merge(int a, int b) {
        return a + b;
    }

    void upd(int pos, int val) {
        pos += size;
        tree[pos] = merge(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = merge(tree[pos], tree[pos ^ 1]);
    }

    int get(int l, int r) {
        if (l > r) return neutral_element;
        int ans = neutral_element;
        for (l += size, r += size + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans = merge(ans, tree[l++]);
            if (r & 1) ans = merge(ans, tree[--r]);
        }
        return ans;
    }
};

#define ff first
#define ss second

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    map<pair<int, int>, int> dp;
    dp[{a[0], 0}] = 0;
    auto upd = [&](map<pair<int, int>, int> &mp, pair<int, int> it, int val) -> void {
        if (mp.count(it)) mp[it] = min(mp[it], val);
        else mp[it] = val;
    };
    for (int i = 1; i < n; i++) {
        map<pair<int, int>, int> nw;
        for (auto &it: dp) {
            upd(nw, make_pair(a[i], it.ff.ss + (a[i] + it.ff.ff <= 0)), it.ss); // nothing chanegs
            if (a[i] + it.ff.ff <= 0) {
                int x = -it.ff.ff + 1;
                upd(nw, make_pair(x, it.ff.ss), it.ss + x - a[i]);
            }
        }
        dp = nw;
    }
    vector<int> ans(n, 1e9);
    for (auto &it: dp) {
        ans[it.ff.ss] = min(ans[it.ff.ss], it.ss);
    }
    int mn = 1e9;
    for (int i = 0; i < n; i++) {
        mn = min(mn, ans[i]);
        ans[i] = mn;
        cout << ans[i] << ' ';
    }
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);

    int queries = 1;
#ifdef sunnatov
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> queries;
#else
    // cin >> queries;
#endif

    for (int test_case = 1; test_case <= queries; test_case++) {
#ifdef sunnatov
        cout << "Test case: " << test_case << endl;
#endif
        solve();
        cout << '\n';
    }
}