#include "bits/stdc++.h"
using namespace std;
using ll = long long;
const ll inf = 1e18;

random_device rd;
mt19937 rng(rd());
int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}


struct segtree {
    vector<int> tree;
    int size;
    int neutral_element = 0;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, neutral_element);
    }

    void build(const vector<int> &a) {
        size = 1;
        while (size < a.size()) size *= 2;
        tree.assign(2 * size, neutral_element);
        for (int i = size; i < size + a.size(); i++) tree[i] = a[i - size];
        for (int i = size - 1; i > 0; i--) tree[i] = merge(tree[i << 1], tree[i << 1 | 1]);
    }

    int merge(int a, int b) {
        return a + b;
    }

    void upd(int pos, int val) {
        pos += size;
        tree[pos] = merge(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = merge(tree[pos], tree[pos ^ 1]);
    }

    int get(int l, int r) {
        if (l > r) return neutral_element;
        int ans = neutral_element;
        for (l += size, r += size + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans = merge(ans, tree[l++]);
            if (r & 1) ans = merge(ans, tree[--r]);
        }
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    vector cost(m + 1, vector(m + 1, 0));
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= m; j++) cin >> cost[i][j];
    }
    vector<int> val(n + 1), first(m + 1), last(m + 1);
    for (int i = 1; i <= n; i++) last[a[i]] = i;
    for (int i = n; i > 0; i--) first[a[i]] = i;
    for (int i = 1; i <= m; i++) {
        if (!last[i]) continue;
        val[first[i]]++;
        val[last[i]]--;
    }
    vector<pair<int, int>> ranges;
    vector<int> id(n + 1);
    int now = 0;
    for (int i = 1; i <= n; i++) {
        if (!now) ranges.emplace_back(i, i);
        else ranges.back().second = i;
        id[i] = ranges.size() - 1;
        now += val[i];
    }
    vector need(ranges.size(), vector(m + 1, 0ll));
    for (int i = 1; i <= m; i++) {
        if (!last[i]) continue;
        int pos = last[i];
        for (int j = 1; j <= m; j++) need[id[pos]][j] += cost[i][j];
    }
    vector<ll> old(m + 1, inf), nw(m + 1, inf);
    old[0] = 0;
    for (int i = 0; i < ranges.size(); i++) {
        ll mn = old[0];
        for (int j = 1; j <= m; j++) {
            mn = min(mn, old[j]);
            nw[j] = mn + need[i][j];
        }
        old = nw;
        nw = vector(m + 1, inf);
    }
    cout << *min_element(old.begin(), old.end());
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);

    int queries = 1;
#ifdef sunnatov
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> queries;
#else
    // cin >> queries;
#endif

    for (int test_case = 1; test_case <= queries; test_case++) {
#ifdef sunnatov
        cout << "Test case: " << test_case << endl;
#endif
        solve();
        cout << '\n';
    }
}