#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN = 4e5;
vector<int> g[MAXN];
int parent[MAXN], jump[MAXN], depth[MAXN], tin[MAXN], tout[MAXN];
int timer = 0;

void dfs(int u, int prev = -1) {
    tin[u] = timer++;
    for (int v : g[u]) {
        if (v == prev) {
            continue;
        }
        parent[v] = u;
        depth[v] = depth[u] + 1;
        if (depth[u] - depth[jump[u]] == depth[jump[u]] - depth[jump[jump[u]]]) {
            jump[v] = jump[jump[u]];
        } else {
            jump[v] = u;
        }
        dfs(v, u);
    }
    tout[u] = timer;
}

bool is_parent(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (depth[v] < depth[u]) swap(u, v);
    while (depth[u] != depth[v]) {
        if (depth[jump[v]] >= depth[u]) {
            v = jump[v];
        } else {
            v = parent[v];
        }
    }
    while (u != v) {
        if (jump[u] != jump[v]) {
            u = jump[u];
            v = jump[v];
        } else {
            u = parent[u];
            v = parent[v];
        }
    }
    return u;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    int q, t;
    cin >> q >> t;
    int last_ans = 0;
    while (q--) {
        int k;
        cin >> k;
        vector<pair<int, int>> R(k);
        for (int i = 0; i < k; i++) {
            cin >> R[i].first >> R[i].second;
            if (t == 2) {
                R[i].first = (R[i].first + last_ans) % (n - 1) + 2;
            }
            R[i].first--;
        }
        sort(R.begin(), R.end(), [&](auto a, auto b) {
            return tin[a.first] < tin[b.first];
        });
        int result = 0;
        map<int, int> pref;
        pref[-1] = 0;
        for (auto [u, c] : R) {
            pref[tin[u]] = pref.rbegin()->second + c;
            result = max(result, (depth[u] + 1) * c);
        }

        for (int i = 0; i < k - 1; i++) {
            int x = lca(R[i].first, R[i + 1].first);
            int sum_c = prev(pref.lower_bound(tout[x]))->second - prev(pref.lower_bound(tin[x]))->second;
            // sum_c with tin on [tin[x], tout[x])
            // for (auto [u, c] : R) {
                // if (is_parent(x, u)) {
                    // sum_c += c;
                // }
            // }
            result = max(result, (depth[x] + 1) * sum_c);
        }
        cout << (last_ans = result) << "\n";
    }
    return 0;
}