#ifdef LOCAL
#define GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;
#define sz(a) (int)(a).size()

template <typename T, typename V> ostream & operator<<(ostream & os, pair<T, V> p) {
    return os << "{" << p.first << "," << p.second << "}";
}

template <class T, class V, class Container> basic_ostream<T, V> & operator<<(basic_ostream<T, V> &os, Container x) {
    os << "[ ";
    for (auto &y : x)
        os << y << " ";
    os << "]";
    return os;
}
template <class T> bool chmin(T &x, T &y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <class T> bool chmax(T &x, T &y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) {
    cerr << H << " ";
    deb_out(T...);
}
#define deb(...) cerr << "(" << (#__VA_ARGS__) << "): "; deb_out(__VA_ARGS__);
#else
#define deb(...) 1
#endif

typedef long long ll;
typedef long double ld;

#define int long long

const int INF = 2e15;
const int N = 1e5 + 5;
void solve_test() {
    auto check = [&](int k) -> bool {
        unordered_map<int, int> cnt;
        for (int d = 2; d * d <= k; ++d) {
            while (k % d == 0) {
                cnt[d]++;
                k /= d;
            }
        }
        if (k != 1)
            cnt[k]++;
        int x = 0;
        for (auto p : cnt) {
            if (p.second == 1) {
                x++;
            } else if (p.second != 2) {
                return false;
            }
        }
        return x <= 1;
    };
    vector<int> ans(N);
    for (int d = 1; d < N; ++d) {
        int last = -1;
        for (int i = 1; i * i <= d; ++i)
            last = i;
        if (last * last == d) {
            ans[d] = d;
        } else {
            ans[d] = ans[d - 1];
        }
    }
    auto solve = [&](auto solve, int n, vector<vector<int>> &res) -> void {
        if (n == 1) {
            res.push_back({1});
            return;
        }
        if (n == 0)
            return;
        if (check(n)) {
            res.push_back({n});
            solve(solve, n - 1, res);
            return;
        }
        int start = -1;
        for (int i = 1; i <= n; ++i) {
            if (i % 2 != n % 2 && check(i + n)) {
                start = i;
                break;
            }
        }
        int l = start, r = n;
        int take = ans[(r - l + 1) / 2];
        res.push_back({});
        
        while (r >= l) {
            if (take == 0) {
                take = ans[(r - l + 1) / 2];
                res.push_back({});
            }
            res.back().push_back(l);
            res.back().push_back(r);
            take--;
            ++l;
            --r;
        }
        solve(solve, start - 1, res);
    };
    int n, m;
    cin >> n >> m;
    vector<vector<int>> res;
    solve(solve, n, res);
    cout << sz(res) << '\n';
    for (auto v : res) {
        cout << sz(v) << '\n';
        for (int x : v)
            cout << x << " ";
        cout << '\n';
    }
    cout << '\n';
    for (auto v : res) {
        int sum = accumulate(v.begin(), v.end(), 0LL);
        deb(sum, check(sum));
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    for (int i = 0; i < tt; ++i) {
        solve_test();
    #ifdef LOCAL
        cout << "______________" << endl;
    #endif
    }
}