//#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


struct segment_tree {
    int n;
    vector<int> tree, add;

    segment_tree(vector<int>& a) {
        n = a.size();
        tree.resize(4 * n, 0);
        add.resize(4 * n, 0);
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int>& a) {
        if (l + 1 == r) {
            tree[v] = a[l];
        }
        else {
            int m = (r + l) / 2;
            build(2 * v, l, m, a);
            build(2 * v + 1, m, r, a);
            tree[v] = tree[2 * v] + tree[2 * v + 1];
        }
    }

    void push(int v, int l, int r){
        int m = (r + l) / 2;
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
        tree[2 * v] += (m - l) * add[v];
        tree[2 * v + 1] += (r - m) * add[v];
        add[v] = 0;
    }

/*    void add(int v, int l, int r, int lx, int rx, int val){
        if (r <= lx || rx <= l){
            return;
        }
        if (lx <= l && r <= rx){
            tree[v] += (r - l) * val;
            add[v] += val;
            return;
        }
        int m = (r + l) / 2;
        add(2 * v, l, m, lx, rx, val);
        add(2 * v + 1, m, r, lx, rx, val);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }*/
};

istream& operator >> (istream& in, vector<int>& a) {
    for (int& i : a) {
        in >> i;
    }
    return in;
}

ostream& operator << (ostream& out, vector<int> a) {
    for (int i : a) {
        out << i << ' ';
    }
    return out;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

    int a, b, n, m;
    cin >> a >> b >> n >> m;

    if (2 * a == b){
        if (2 * n == m){
            cout << n << " 0";
        } else {
            cout << -1;
        }
    } else {
        int k = (m - 2 * n) / (b - 2 * a);
        int l = n - k * a;
        if (l >= 0 && k >= 0 && n == k * a + l && m == k * b + 2 * l){
            cout << l << " " << k;
        } else {
            cout << -1;
        }
    }

    return 0;
}