//#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 9e18;

struct segment_tree {
    int n;
    vector<int> tree, add;

    segment_tree(vector<int>& a) {
        n = a.size();
        tree.resize(4 * n, 0);
        add.resize(4 * n, 0);
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int>& a) {
        if (l + 1 == r) {
            tree[v] = a[l];
        }
        else {
            int m = (r + l) / 2;
            build(2 * v, l, m, a);
            build(2 * v + 1, m, r, a);
            tree[v] = tree[2 * v] + tree[2 * v + 1];
        }
    }

    void push(int v, int l, int r){
        int m = (r + l) / 2;
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
        tree[2 * v] += (m - l) * add[v];
        tree[2 * v + 1] += (r - m) * add[v];
        add[v] = 0;
    }

/*    void add(int v, int l, int r, int lx, int rx, int val){
        if (r <= lx || rx <= l){
            return;
        }
        if (lx <= l && r <= rx){
            tree[v] += (r - l) * val;
            add[v] += val;
            return;
        }
        int m = (r + l) / 2;
        add(2 * v, l, m, lx, rx, val);
        add(2 * v + 1, m, r, lx, rx, val);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }*/
};

istream& operator >> (istream& in, vector<int>& a) {
    for (int& i : a) {
        in >> i;
    }
    return in;
}

ostream& operator << (ostream& out, vector<int> a) {
    for (int i : a) {
        out << i << ' ';
    }
    return out;
}

int32_t main() {
    //ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> ans(n, INF);

    int k = 0;
    for (int i = 1; i < n; ++i){
        if (a[i - 1] + a[i] <= 0){
            k++;
        }
    }
    ans[k] = 0;
    int orig_k = k;

    vector<vector<int>> b(n, a);
    k--;
    for (; k >= 0; --k){
        int mn_cost_1 = INF, mn_pos_1 = -1;
        for (int i = 0; i < n; ++i){
            if (b[k + 1][i] < 0){
                if (i == 0){
                    if (b[k + 1][i] + b[k + 1][i + 1] <= 0){
                        if (mn_cost_1 > -(b[k + 1][i] + b[k + 1][i + 1]) + 1){
                            mn_cost_1 = -(b[k + 1][i] + b[k + 1][i + 1]) + 1;
                            mn_pos_1 = i;
                        }
                    }
                } else if (i == n - 1){
                    if (b[k + 1][i] + b[k + 1][i - 1] <= 0){
                        if (mn_cost_1 > -(b[k + 1][i] + b[k + 1][i - 1]) + 1){
                            mn_cost_1 = -(b[k + 1][i] + b[k + 1][i - 1]) + 1;
                            mn_pos_1 = i;
                        }
                    }
                } else {
                    if (b[k + 1][i] + b[k + 1][i - 1] <= 0){
                        if (mn_cost_1 > -(b[k + 1][i] + b[k + 1][i - 1]) + 1){
                            mn_cost_1 = -(b[k + 1][i] + b[k + 1][i - 1]) + 1;
                            mn_pos_1 = i;
                        }
                    }
                    if (b[k + 1][i] + b[k + 1][i + 1] <= 0){
                        if (mn_cost_1 > -(b[k + 1][i] + b[k + 1][i + 1]) + 1){
                            mn_cost_1 = -(b[k + 1][i] + b[k + 1][i + 1]) + 1;
                            mn_pos_1 = i;
                        }
                    }
                }
            }
        }
        b[k] = b[k + 1];
        b[k][mn_pos_1] = 1;
        ans[k] = ans[k + 1] + mn_cost_1;
    }

    for (int i = 0; i < orig_k; ++i){
        cout << ans[i] << " ";
    }
    for (int i = orig_k; i < n; ++i){
        cout << "0 ";
    }




    return 0;
}