#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#define int long long
#define ll long long
#define printv(V) for (auto X : V) {cout << X << " ";} cout << endl;
#define printw(W) for (auto V : W) {printv(V)}
#define fi first
#define se second


using namespace std;

struct Col {
    int f, c;

    bool operator<(Col other) {
        if (f == other.f) {
            return c > other.c;
        }
        return f < other.f;
    }
};

vector<int> p(1001);
vector<int> sz(1001, 1);

int get(int x) {
//    cout << x << endl;
    if (p[x] == x) {
        return x;
    }
    return p[x] = get(p[x]);

}

void merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (sz[b] > sz[a]) {
        swap(a, b);
    }
    if (a == b) {
        return;
    }
    p[b] = a;
    sz[a] += sz[b];
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(0);
   #define endl "\n"
#endif
    int n, m;
    cin >> n >> m;
    vector<int> numb(n);
    vector<int> fn(m, 1e10);
    vector<int> ln(m, -1);
    vector<Col> g;
    vector<vector<int>> cost(m, vector<int>(m));

    std::iota(p.begin(), p.end(), 0);

    for (int i = 0; i < n; ++i) {
        cin >> numb[i];
        numb[i]--;
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        fn[numb[i]] = min(i, fn[numb[i]]);
        ln[numb[i]] = i;
    }
    for (int i = 0; i < m; ++i) {
        Col x, y;
        if (ln[i] != -1) {
            x.f = fn[i];
            y.f = ln[i];
            x.c = i + 1;
            y.c = -i - 1;
            g.push_back(x);
            g.push_back(y);
        }
    }
    std::sort(g.begin(), g.end());

    int cur = -1;
    int c_cur = 0;
    for (auto x : g) {
//        cout << x.f << " " << x.c << endl;
        if (c_cur == 0) {
            cur = get(x.c - 1);
            c_cur = 1;
        } else {
            if (x.c >= 0) {
                c_cur += 1;
                merge(cur, x.c - 1);
            }
            if (x.c - 1 < 0) {
                c_cur -= 1;
            }
        }
    }

//    for (int i = 0; i < m; ++i) {
//        cout << get(i) << " ";
//    }
    for (int i = 0; i < m; ++i) {
        int x = get(i);
        if (i != x) {
            for (int j = 0; j < m; ++j) {
                cost[x][j] += cost[i][j];
            }
        }
    }
    vector<int> nc;
    int pr = -1;
    for (int i = 0; i < n; ++i) {
        int h = get(numb[i]);
        if(h != pr) {
            nc.push_back(h);
        }
        pr = h;
    }
//    cout << endl;
//    cout << endl;
//    printv(nc)
//    cout << endl;
//    cout << endl;
    vector<vector<int>> dp(nc.size() + 1, vector<int>(m, 0));
    for (int i = 1; i < nc.size() + 1; ++i) {
        int min_pr = dp[i - 1][0];
        int col = nc[i - 1];
        for (int j = 0; j < m; ++j) {
            min_pr = min(min_pr, dp[i - 1][j]);
            dp[i][j] = min_pr + cost[col][j];
        }
    }

    int ans = 1e18;
    for (int i = 0; i < m; ++i) {
        ans = min(ans, dp[nc.size()][i]);
    }
    cout << ans << endl;
//    printw(dp)
//    cout << endl;
//    printw(cost)

}