#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define gen(a, b) uniform_int_distribution<int>(a, b)(rnd)
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#ifndef LOCAL
#define endl '\n'
#endif
const int N = 4e5 + 1000;
vector<int> G[N];
int tin[N];
int tout[N];
int d[N];
struct Fenwick {
    int n;
    vector<int> a;

    Fenwick(int n_ = 0) {
        init(n_);
    }

    void init(int n_) {
        n = n_;
        a.assign(n, {});
    }

    void add(int x, const int& v) {
        for (int i = x + 1; i <= n; i += i & -i) {
            a[i - 1] = a[i - 1] + v;
        }
    }

    int sum(int x) {
        int ans{};
        for (int i = x; i > 0; i -= i & -i) {
            ans = ans + a[i - 1];
        }
        return ans;
    }

    int rangeSum(int l, int r) {
        return sum(r + 1) - sum(l);
    }

    int select(const int& k) {
        int x = 0;
        int cur{};
        for (int i = 1 << __lg(n); i; i /= 2) {
            if (x + i <= n && cur + a[x + i - 1] <= k) {
                x += i;
                cur = cur + a[x - 1];
            }
        }
        return x;
    }
};
int tt = 0;
const int logn = 20;
int up[N][logn];

void dfs(int v, int p) {
    tin[v] = tt++;
    for (auto u : G[v]) {
        if (u == p)
            continue;
        up[u][0] = v;
        d[u] = d[v] + 1;
        dfs(u, v);
    }
    tout[v] = tt;
}
bool a(int u, int v) {
    return tin[u] <= tin[v] && tin[v] < tout[u];
}

int lca(int v, int u) {
    if (a(v, u))
        return v;
    if (a(u, v))
        return u;
    for (int l = logn - 1; l >= 0; l--)
        if (!a(up[v][l], u))
            v = up[v][l];
    return up[v][0];
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        G[u].push_back(v);
        G[v].push_back(u);
    }
    dfs(0, -1);
    for(int j = 0; j < logn -1; j++) {
        for(int i = 0; i < n; i++) {
            up[i][j + 1] = up[up[i][j]][j];
        }
    }
    Fenwick T(n);
    int q, t;
    cin >> q >> t;
    int lastans = 0;
    if (t == 1) {
        while (q--) {
            int k;
            cin >> k;
            vector<pair<int, int>> sp;
            vector<pair<int, int>> s;
            for (int i = 0; i < k; i++) {
                int v, c;
                cin >> v >> c;
                v--;
                sp.push_back({v, c});
                T.add(tin[v], c);
                s.push_back({tin[v], v});
            }
            sort(all(s));
            int ans = 0;
            for (int i = 0; i < s.size() - 1; i++) {
                int la = lca(s[i].second, s[i + 1].second);
                ans = max(ans, (d[la] + 1) * T.rangeSum(tin[la], tout[la] - 1));
            }
            for (int i = 0; i < s.size(); i++) {
                int la = s[i].second;
                ans = max(ans, (d[la] + 1) * T.rangeSum(tin[la], tout[la] - 1));
            }
            cout << ans << endl;
            for (auto [v, c] : sp) {
                T.add(tin[v], -c);
            }
        }
    } else {
         while (q--) {
            int k;
            cin >> k;
            vector<pair<int, int>> sp;
            vector<pair<int, int>> s;
            for (int i = 0; i < k; i++) {
                int v, c;
                cin >> v >> c;
                v =(v + lastans) % (n - 1) + 2;
                v--;
                sp.push_back({v, c});
                T.add(tin[v], c);
                s.push_back({tin[v], v});
            }
            sort(all(s));
            int ans = 0;
            for (int i = 0; i < s.size() - 1; i++) {
                int la = lca(s[i].second, s[i + 1].second);
                ans = max(ans, (d[la] + 1) * T.rangeSum(tin[la], tout[la] - 1));
            }
            for (int i = 0; i < s.size(); i++) {
                int la = s[i].second;
                ans = max(ans, (d[la] + 1) * T.rangeSum(tin[la], tout[la] - 1));
            }
            cout << ans << endl;
            lastans = ans;
            for (auto [v, c] : sp) {
                T.add(tin[v], -c);
            }
        }
    }
}