#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937 rnd(556);
constexpr long long inf = 1e18;
constexpr long long N = 2e3 + 556;
constexpr long long A = 26;
constexpr long long T = 20;

int p[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

int unite(int a, int b) {
    a = get(a); b = get(b);
    if (a == b) return 0;
    if (rnd() & 1) {
        p[a] = b;
    } else {
        p[b] = a;
    }
    return 1;
}

void solve() {
    for (int i = 0; i < N; i++) {
        p[i] = i;
    }

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    cin >> a;
    vector<vector<int>> gr(m, vector<int> (m));
    cin >> gr;

    for (auto& el : a) el--;

    vector<int> cl(n, -1);
    vector<int> cur;
    vector<vector<int>> pos(m, vector<int> (0));

    for (int i = 0; i < n; i++) {
        if (cl[a[i]] == -1) cl[a[i]] = i;
        if (pos[a[i]].size()) {
            while (cur.size() && cur.back() > pos[a[i]].back()) {
                // cl[a[cur.back()]] = cl[a[i]];
                unite(a[i], a[cur.back()]);
                cur.pop_back();
            }
        }
        cur.push_back(i);
        pos[a[i]].push_back(i);
    }

    vector<int> b(n, 0);
    for (int i = 0; i < n; i++) {
        b[i] = get(a[i]);
    }

    b.erase(unique(b.begin(), b.end()), b.end());

    vector<vector<int>> cm(m, vector<int> (0));
    for (int i = 0; i < m; i++) {
        cm[get(i)].push_back(i);
    }

    // cout << cm[0] << endl;

    vector<vector<int>> gt(m, vector<int> (m, 0));
    for (int i = 0; i < m; i++) {

        // cout << i << ": " << cm[i] << endl;

        for (int to = 0; to < m; to++) {
            for (auto el : cm[i]) {
                gt[i][to] += gr[el][to];
            }
        }
    }

    // for (auto el : gt) cout << el << endl;
    // cout << endl;

    // cout << b << endl;

    int k = b.size();

    vector<vector<int>> dp(k, vector<int> (m, inf));
    for (int j = 0; j < m; j++) {
        dp[0][j] = gt[b[0]][j];

        if (j) {
            dp[0][j] = min(dp[0][j], dp[0][j - 1]);
        }
    }

    // cout << gt[b[0]] << endl;

    for (int i = 1; i < k; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = min(dp[i][j], dp[i - 1][j] + gt[b[i]][j]);

            if (j) {
                dp[i][j] = min(dp[i][j], dp[i][j - 1]);
            }
        }
    }

    // cout << gt[0][1] << endl;

    cout << dp[k - 1][m - 1] << endl;


    // for (int i = 0; i < n; i++) {
    //     cout << get(a[i]) << " ";
    // }
    // cout << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}