#include <bits/stdc++.h>

#define int int64_t

using namespace std;

const int INF = 1e18;
const int MAXN = 4e5;
const long double DIS = 2e8;

vector <int> vp[MAXN];

vector <int> sz(MAXN);
vector <int> h(MAXN);
vector <int> prv(MAXN);
vector <int> pred(MAXN);

vector <int> col(MAXN);

vector <int> ps(MAXN);
vector <int> euler;

void dfs(int v, int pr){
    prv[v] = pr;
    if(pr != -1){
        h[v] = h[pr] + 1;
    }
    int pos_mx = -1;
    for(int i = 0; i < vp[v].size(); i++){
        int to = vp[v][i];
        if(to == pr){
            continue;
        }
        dfs(to, v);
        if(pos_mx == -1 || sz[vp[v][pos_mx]] < sz[to]){
            pos_mx = i;
        }
        sz[v] += sz[to];
    }
    if(pos_mx != -1){
        swap(vp[v][0], vp[v][pos_mx]);
    }
    sz[v]++;
}

int color = 0;

void build_hld(int v, int pr, int cl){
    ps[v] = euler.size();
    euler.push_back(v);
    col[v] = cl;
    for(auto to:vp[v]){
        if(to == pr){
            continue;
        }
        if(sz[to] * 2 > sz[v]){
            build_hld(to, v, cl);
        }
        else{
            pred[color] = to;
            build_hld(to, v, color++);
        }
    }
}

struct node{
    int tad = 0;
    int ta = 0;
    int sm = 0;
    node(){

    }
};

node tr[4 * MAXN];

void build(int v, int l, int r){
    if(r - l == 1){
        tr[v].sm = 0;
        return;
    }
    build(2 * v, l, l + r >> 1);
    build(2 * v + 1, l + r >> 1, r);
    tr[v].sm = tr[2 * v].sm + tr[2 * v + 1].sm;
}

void push(int v, int l, int r){
    if(tr[v].tad != 0 || tr[v].ta != 0){
        //cout << "IN: " << l << ' ' << r << ' ' << tr[v].tad << ' ' << tr[v].ta << endl;
        tr[v].sm += tr[v].tad * (r - l);
        tr[v].sm += (r - l) * ((r - l - 1) * tr[v].ta) / 2;
        if(r - l != 1){
            tr[2 * v].tad += tr[v].tad;
            tr[2 * v].ta += tr[v].ta;
            tr[2 * v + 1].tad += tr[v].tad + (((l + r) / 2 - l) * tr[v].ta);
            tr[2 * v + 1].ta += tr[v].ta;
        }
        tr[v].tad = 0;
        tr[v].ta = 0;
    }
}

void add(int v, int l, int r, int ll, int rr, int a, int b){
    push(v, l, r);
    if(l >= rr || r <= ll){
        return;
    }
    if(l >= ll && r <= rr){
        tr[v].ta += a;
        tr[v].tad += a * (l - ll) + b;
        push(v, l, r);
        return;
    }
    add(2 * v, l, l + r >> 1, ll, rr, a, b);
    add(2 * v + 1, l + r >> 1, r, ll, rr, a, b);
    tr[v].sm = tr[2 * v].sm + tr[2 * v + 1].sm;
}

int get(int v, int l, int r, int ps){
    push(v, l, r);
    if(l == ps && r == ps + 1){
        return tr[v].sm;
    }
    if((l + r >> 1) <= ps){
        return get(2 * v + 1, l + r >> 1, r, ps);
    }
    return get(2 * v, l, l + r >> 1, ps);
}

int n;

map <int, int> mp;
multiset <int> ans;
/*
5
1 2
3 1
4 3
3 5
2 2
3
0 7
3 4
2 4
3
1 4
2 2
3 1
*/
void go(multiset <vector<int>> ms, int d){
    while(ms.size()){
        vector <int> vec = *ms.rbegin();
        ms.erase(--ms.end());
        int v = vec[1];
        int c = vec[2];
        int lst = pred[col[v]];
        if(mp.find(v) != mp.end()){
            ans.erase(ans.find(mp[v]));
        }
        //cout << "NOW: " << v << ' ' << c << ' ' << ps[lst] << ' ' << ps[v] << ' ' << lst << ' ' << d * (h[lst] + 1) * c << endl;
        add(1, 0, n, ps[lst], ps[v] + 1, d * c, d * (h[lst] + 1) * c);
        int nw = get(1, 0, n, ps[v]);
        //cout << nw << endl;
        mp[v] = nw;
        ans.insert(nw);
        v = prv[pred[col[v]]];
        if(v != -1){
            ms.insert({h[v], v, c});
        }
    }
}

void solve(){
    cin >> n;
    for(int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vp[a].push_back(b);
        vp[b].push_back(a);
    }
    dfs(0, -1);
    pred[color] = 0;
    build_hld(0, -1, color++);
    int q, t;
    cin >> q >> t;
    int l_ans = 0;
    while(q--){
        int k;
        cin >> k;
        if(t == 1){
            multiset <vector<int>> ms1, ms2;
            for(int i = 0; i < k; i++){
                int a, b;
                cin >> a >> b;
                a--;
                ms1.insert({h[a], a, b});
            }
            ms2 = ms1;
            go(ms1, 1);
            cout << *ans.rbegin() << endl;
            go(ms2, -1);
            ans.clear();
            mp.clear();
        }
        else{
            multiset <vector<int>> ms1, ms2;
            for(int i = 0; i < k; i++){
                int a, b;
                cin >> a >> b;
                a = (a + l_ans) % (n - 1) + 2;
                a--;
                ms1.insert({h[a], a, b});
            }
            ms2 = ms1;
            go(ms1, 1);
            l_ans = *ans.rbegin();
            cout << *ans.rbegin() << endl;
            go(ms2, -1);
            ans.clear();
            mp.clear();
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}