#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <algorithm>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<bool> vb;

const int N = 1e4;
const int INF = 2e9;
const ll LINF = 1e18;

bool is_nice(ll n) {
  bool odd = 0;
  for (ll d = 2; d * d <= n; d++) {
    if (n % d == 0) {
      int c = 0;
      while (n % d == 0) {
        n /= d;
        c++;
      }
      if (c & 1) {
        if (odd) return 0;
        odd = 1;
      }
    }
  }
  if (odd && n > 1) return 0;
  return 1;
}

bool is_prime(ll n) {
  for (ll d = 2; d * d <= n; d++) {
    if (n % d == 0) {
      return 0;
    }
  }
  return 1;
}

void init() {
  vb nice(N, false);
  vb pr(N, 1);
  vi prime, nc;
  for (int d = 2; d < N; d++) {
    if (pr[d] == 0) continue;
    for (int k = 2; d * k < N; k++) {
      pr[d * k] = 0;
    }
    prime.push_back(d);
    cout << d << ' ';
  }
  cout << '\n';
  for (int i = 1; i * i < N; i++) {
    nice[i * i] = 1;
    for (int p : prime) {
      if (i * i * p >= N) break;
      nice[i * i * p] = 1;
    }
  }
  cout << "check\n";
  for (int i = 0; i < 1e2; i++) {
    cout << nice[i] << ' ' << is_nice(i) << '\n';
    /*if (nice[i]) {
      cout << i << ' ';
      nc.push_back(i);
    }*/
  }
  cout << '\n';
  /*for (int i = 2; i * i < N; i++) {
    int n = i * (i + 1) / 2;
    auto it = lower_bound(all(nc), n);
    auto prv = prev(it);
    cout << n << ' ' << *prv << ' ' << *it << '\n';
  }*/
}

void solve() {
  ll n, m;
  cin >> n >> m;
  // init();
  ll k = n * (n + 1) / 2;
  if (is_nice(k)) {
    cout << "1\n" << n << '\n';
    for (int i = 1; i <= n; i++) cout << i << ' ';
    cout << '\n';
  } else {
    for (int i = 1; i < 1000; i++) {
      if (is_nice(i) && is_nice(k - i)) {
        cout << "2\n1\n" << i << '\n' << n - 1 << '\n';
        for (int j = 1; j <= n; j++) {
          if (j != i) cout << j << ' ';
        }
        cout << '\n';
        return;
      }
    }
  }
}

int main() {
#ifdef LOCAL
  freopen("input.in", "r", stdin);
#endif
  int t = 1;
  while (t--) solve();
}