#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <algorithm>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<bool> vb;

const int N = 1e4;
const int INF = 2e9;
const ll LINF = 1e18;

void solve() {
  int n;
  cin >> n;
  vi arr(n);
  for (int &i : arr) cin >> i;
  vector<vi> precalc(n, vi(n));
  for (int i = 0; i < n; i++) {
    for (int l = 0; l < n; l++) {
      if (i == 0) precalc[i][l] = arr[0];
      else if (l == 0) precalc[i][l] = arr[i];
      else {
        int prev = precalc[i - 1][l - 1];
        if (arr[i] + prev > 0) precalc[i][l] = arr[i];
        else precalc[i][l] = 1 - prev;
      }
    }
  }
  /*for (int i = 0; i < n; i++) {
    for (int l = 0; l < n; l++) {
      cout << precalc[i][l] << ' ';
    }
    cout << '\n';
  }*/
  vector<vl> dp1(n, vl(n, LINF));  // dp[index][bad_pairs][number_of_incremented_elements]
  vector<vl> dp2(n, vl(n, LINF));  // dp[index][bad_pairs][number_of_incremented_elements]
  dp1[0][0] = 0;
  for (int i = 1; i < n; i++) {
    for (int pr = 0; pr < n; pr++) {
      for (int len = 0; len <= i; len++) {
        if (dp1[pr][len] == LINF) continue;
        int prev = precalc[i - 1][len];
        if (arr[i] + prev > 0) {
          dp2[pr][0] = min(dp2[pr][0], dp1[pr][len]);
          continue;
        }
        if (pr < n - 1) {
          dp2[pr + 1][0] = min(dp2[pr + 1][0], dp1[pr][len]);
        }
        dp2[pr][len + 1] = min(dp2[pr][len + 1], dp1[pr][len] + -(arr[i] + prev) + 1);
      }
    }
    dp1 = dp2;
    for (int ii = 0; ii < n; ii++) {
      for (int j = 0; j < n; j++) {
        dp2[ii][j] = LINF;
      }
    }
  }
  ll mn = LINF;
  for (int k = 0; k < n; k++) {
    for (int len = 0; len < n; len++) {
      mn = min(mn, dp1[k][len]);
    }
    cout << mn << ' ';
  }
  cout << '\n';
}

int main() {
#ifdef LOCAL
  freopen("input.in", "r", stdin);
#endif
  int t = 1;
  while (t--) solve();
}