#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <algorithm>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<bool> vb;

const int N = 1e4;
const int INF = 2e9;
const ll LINF = 1e18;

int n;
vector<vi> adj;
vi p, d;

void dfs(int v, int par, int dep=0) {
  p[v] = par;
  d[v] = dep;
  for (int u : adj[v]) {
    if (u == par) continue;
    dfs(u, v, dep + 1);
  }
}

void solve() {
  cin >> n;
  adj.resize(n + 1);
  p.resize(n + 1);
  d.resize(n + 1);
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    adj[u].push_back(v);
    adj[v].push_back(u);
  }
  dfs(1, 0, 1);
  int q, t;
  cin >> q >> t;
  while (q--) {
    ll mx = 0;
    vl arr(n + 1);
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
      int v, c;
      cin >> v >> c;
      for (int u = v; u != 0; u = p[u]) {
        arr[u] += c;
        mx = max(arr[u] * d[u], mx);
      }
    }
    cout << mx << '\n';
  }
}

int main() {
#ifdef LOCAL
  freopen("input.in", "r", stdin);
#endif
  int t = 1;
  while (t--) solve();
}