#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

vector<ll> p, sz;

ll up(ll v) {
    if (p[v] == v) return v;
    return p[v] = up(p[v]);
}

void unite(ll u, ll v) {
    u = up(u); v = up(v);
    if (u == v) return;
    if (sz[u] > sz[v]) swap(u, v);
    p[u] = v;
    sz[v] += sz[u];
}

int main() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    vector<pii> bounds(m, {n, -1});
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        bounds[a[i]].first = min(bounds[a[i]].first, i);
        bounds[a[i]].second = max(bounds[a[i]].second, i);
    }
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    p.resize(m);
    iota(all(p), 0);
    sz.assign(m, 1);
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            if (bounds[i].first == n || bounds[j].first == n) continue;
            if (bounds[i].first > bounds[j].first && bounds[i].first < bounds[j].second || bounds[i].second > bounds[j].first && bounds[i].second < bounds[j].second) {
                unite(i, j);
            }
        }
    }
    vector<vector<ll>> blocks(m, vector<ll>(m, INF)); //cost to transform block with root i into color j
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            if (bounds[i].first == n) continue;
            if (blocks[up(i)][j] == INF) blocks[up(i)][j] = cost[i][j];
            else blocks[up(i)][j] += cost[i][j];
        }
    }
    vector<ll> roots;
    for (ll i = 0; i < n; ++i) {
        ll r = up(a[i]);
        if (roots.empty() || roots.back() != r) roots.push_back(r);
    }
    vector<vector<ll>> dp(roots.size(), vector<ll>(m));
    vector<ll> best(m, INF);
    for (ll i = 0; i < m; ++i) {
        dp[0][i] = blocks[roots[0]][i];
    }
    for (ll i = 1; i < roots.size(); ++i) {
        best[0] = dp[i - 1][0];
        for (ll j = 1; j < m; ++j) {
            best[j] = min(best[j - 1], dp[i - 1][j]);
        }
        for (ll j = 0; j < m; ++j) {
            dp[i][j] = best[j] + blocks[roots[i]][j];
        }
    }
    ll ans = INF;
    for (ll i = 0; i < m; ++i) {
        ans = min(ans, dp[roots.size() - 1][i]);
    }
    cout << ans;
}