#include <bits/stdc++.h>
using namespace std;

const int LOG(19);

void dfs(vector<vector<int>>& g, int x, int p, vector<int>& prs,
         vector<int>& hs, int h, vector<int>& tin, int& t) {
    tin[x] = t;
    prs[x] = p;
    hs[x] = h;
    t++;
    for (auto i : g[x]) {
        if (i != p) {
            dfs(g, i, x, prs, hs, h + 1, tin, t);
        }
    }
}

void binpps(vector<vector<int>>& binups, vector<int>& prs, int n) {
    binups.assign(n, vector<int>(LOG, -1));
    for (int i = 0; i < n; i++) {
        binups[i][0] = prs[i];
    }
    for (int i = 1; i < LOG; i++) {
        for (int j = 0; j < n; j++) {
            if (binups[j][i - 1] != -1) {
                binups[j][i] = binups[binups[j][i - 1]][i - 1];
            }
        }
    }
}

int lca(int a, int b, vector<vector<int>>& binups, vector<int>& hs) {
    //cout << a << " " << b << endl;
    if (hs[a] > hs[b]) {
        swap(a, b);
    }
    int dif(hs[b] - hs[a]);
    for (int i = LOG - 1; i >= 0; i--) {
        if (dif >= (1 << i)) {
            dif -= 1 << i;
            b = binups[b][i];
        }
    }
    if (a == b) {
        //cout << a << endl;
        return a;
    }
    for (int i = LOG - 1; i > 0; i--) {
        if (binups[a][i] != binups[b][i]) {
            a = binups[a][i];
            b = binups[b][i];
        }
    }
    return binups[a][0];
}

void zip_a_tree(vector<int>& v, vector<int>& tin, vector<vector<int>>& binups,
                vector<int>& hs, vector<int>& ps, vector<int>& rs) {
    vector<pair<int, int>> u{};
    for (auto i : v) {
        u.push_back({tin[i], i});
    }
    sort(u.begin(), u.end());
    vector<int> w{u[0].second};
    rs.push_back(u[0].second);
    for (int i = 1; i < u.size(); i++) {
        int z(lca(w.back(), u[i].second, binups, hs));
        //cout << w.back() << " " << u[i].second << " " << z << endl;
        int most_recently_popped(-1);
        while (w.size() > 0) {
            if (hs[w.back()] > hs[z]) {
                most_recently_popped = w.back();
                w.pop_back();
            } else {
                break;
            }
        }
        if (most_recently_popped != -1) {
            ps[most_recently_popped] = z;
        }
        if (w.size() == 0) {
            ps[z] = -1;
            w.push_back(z);
            rs.push_back(z);
        } else if (w.back() != z) {
            ps[z] = w.back();
            w.push_back(z);
            rs.push_back(z);
        }
        if (u[i].second != z) {
            ps[u[i].second] = z;
            w.push_back(u[i].second);
            rs.push_back(u[i].second);
        }
    }
}

void dfs2(int x, vector<vector<int>>& children, vector<long long>& cs, vector<int>& hs, long long& ans) {
    for (auto i : children[x]) {
        dfs2(i, children, cs, hs, ans);
        cs[x] += cs[i];
    }
    ans = max(ans, cs[x] * (hs[x] + 1));
}

long long generate_answer(vector<int>& v, vector<int>& c, vector<int>& tin, vector<vector<int>>& binups,
                vector<int>& hs, vector<int>& ps, vector<long long>& cs, vector<vector<int>>& children) {
    vector<int> rs{};
    zip_a_tree(v, tin, binups, hs, ps, rs);
    int root(-1);
    //cout << "TEST" << endl;
    for (auto i : rs) {
        if (ps[i] != -1) {
            children[ps[i]].push_back(i);
        } else {
            root = i;
        }
    }
    for (int i = 0; i < v.size(); i++) {
        cs[v[i]] += c[i];
    }
    long long ans(0);
    dfs2(root, children, cs, hs, ans);
    for (auto i : rs) {
        children[i].clear();
        cs[i] = 0;
        ps[i] = -1;
    }
    return ans;
}

int main() {
    int n, q, r;
    cin >> n;
    vector<vector<int>> g(n, vector<int>(0));
    for (int i = 0; i < n - 1; i++) {
        cin >> q >> r;
        q--;
        r--;
        g[q].push_back(r);
        g[r].push_back(q);
    }
    vector<int> prs(n), hs(n), tin(n);
    int tim(0);
    dfs(g, 0, -1, prs, hs, 0, tin, tim);
    vector<vector<int>> binups;
    binpps(binups, prs, n);
    vector<vector<int>> children(n, vector<int>(0));
    vector<long long> cs(n, 0);
    vector<int> ps(n, -1);
    int m, t;
    long long lastans(0);
    cin >> m >> t;
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        vector<int> v{}, c{};
        for (int j = 0; j < k; j++) {
            cin >> q >> r;
            if (t == 2) {
                q = (q + lastans) % (n - 1) + 2;
            }
            q--;
            v.push_back(q);
            c.push_back(r);
        }
        lastans = generate_answer(v, c, tin, binups, hs, ps, cs, children);
        cout << lastans << endl;
    }
}
