#include <bits/stdc++.h>

using namespace std;

using ll = long long;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
const int INF = INT_MAX;

int n, T = 0;
vector<vector<int>> g, comp;
vector<int> h, pr, tin;
vector<ll> sm;
vector<vector<int>> binUp;

int lca(int a, int b) {
    if (h[a] < h[b]) swap(a, b);
    for (int lg = 19; lg >= 0; lg--) {
        if (h[binUp[lg][a]] >= h[b]) a = binUp[lg][a];
    }
    if (a == b) return a;
    for (int lg = 19; lg >= 0; lg--) {
        if (binUp[lg][a] != binUp[lg][b]) {
            a = binUp[lg][a];
            b = binUp[lg][b];
        }
    }
    return pr[a];
}

void dfs1(int v, int p) {
    pr[v] = p;
    tin[v] = T++;
    for (int u : g[v]) {
        if (u == p) continue;
        h[u] = h[v] + 1;
        dfs1(u, v);
    }
}

void dfs2(int v) {
    for (int u : comp[v]) {
        dfs2(u);
        sm[v] += sm[u];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    g.assign(n, {});
    comp.assign(n, {});
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    pr.assign(n, -1);
    h.assign(n, 0);
    sm.assign(n, 0);
    tin.assign(n, 0);
    dfs1(0, 0);

    binUp.resize(20, vector<int> (n));
    for (int i = 0; i < n; i++) binUp[0][i] = pr[i];
    for (int lg = 1; lg < 20; lg++) {
        for (int i = 0; i < n; i++) {
            binUp[lg][i] = binUp[lg - 1][binUp[lg - 1][i]];
        }
    }

    int q, t;
    ll last_ans = 0;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<pair<int, int>> vert;
        for (int i = 0; i < k; i++) {
            int v, c;
            cin >> v >> c;
            if (t == 1) {
                vert.emplace_back(tin[v - 1], v - 1);
                sm[v - 1] += c;
            } else {
                v = (v + last_ans) % (n - 1) + 1;
                vert.emplace_back(tin[v], v);
                sm[v] += c;
            }
        }
        sort(vert.begin(), vert.end());
        set<pair<int, int>> allE;
        set<int> allV;
        allV.insert(0);
        stack<int> st;
        st.push(0);
        for (auto [tm, v] : vert) {
            int u = lca(v, st.top());
            int lastDel = -1;
            while (!st.empty() && h[st.top()] > h[u]) {
                lastDel = st.top();
                st.pop();
            }
            if (st.top() != u) {
                allE.erase({st.top(), lastDel});
                allE.insert({st.top(), u});
                allE.insert({u, lastDel});
                allE.insert({u, v});
                st.push(u);
                st.push(v);
            } else {
                st.push(v);
                allE.insert({u, v});
            }
        }
        for (auto [a, b] : allE) {
//            cout << "edge " << a + 1 << " " << b + 1 << endl;
            allV.insert(a);
            allV.insert(b);
            comp[a].push_back(b);
        }

        dfs2(0);

        last_ans = 0;
        for (int v : allV) last_ans = max(last_ans, (h[v] + 1) * sm[v]);
        cout << last_ans << '\n';
        allE.clear();
        for (int v : allV) comp[v].clear();
        for (int v : allV) sm[v] = 0;
        allV.clear();
    }
}