// @maximka228
   
#pragma GCC optimize("O3") // the most "agressive" optimization
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
   
#include "bits/stdc++.h"
   
const int64_t MODULO = 1000000007;
const double PI = 3.14159265359;
const std::string ENDL = "\n";

// Hints:
// 1) Interval tasks solution ways: 1) prefix sums (prefix xors) or difference array 2) segment tree or fenwick tree 3) idea/constructive.
// 2) If the condition of the problem mentions 1) only 2 choices (for example, a problem about numbers consisting only of the digits 4 and 7) 2) any power of two (2, 4, 8 ...), then this is a bitmask problem.
// 3) Subsequences (array, string and so on) tasks solution ways: 1) DP 2) prefix sums (prefix xors) 3) two pointers.
   
// If you think, that your solution is correct, but you are still getting errors, check:
// 1) Overflow.
// 2) Such cases as n = 1 and so on. Also check task restrictions.
// 3) Memory usage.
 
int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
   
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int64_t n;
    std::cin >> n;
    
    std::vector<int64_t> as(n), bs(n), cs(n), ds(n);
    
    for (int64_t i = 0; i < n; ++i) {
        std::cin >> as[i];
    }
    
    for (int64_t i = 0; i < n; ++i) {
        std::cin >> bs[i];
    }
    
    for (int64_t i = 0; i < n; ++i) {
        std::cin >> cs[i];
    }
    
    for (int64_t i = 0; i < n; ++i) {
        std::cin >> ds[i];
    }
    
    std::vector<std::pair<int64_t, int64_t>> clocks;
    
    for (int64_t i = 0; i < n; ++i) {
        int64_t a = as[i], b = bs[i], c = cs[i], d = ds[i];
        
        int64_t first = 0, second = 0;
        
        if (!a) {
            first = c;
            second = d;
        } else {
            if (a < 0) {
                first = (std::abs(a) / b + 1) * c;
                second = 0;
            } else {
                first = 0;
                second = (a / b + 1) * d;
            }
        }
        
        clocks.push_back({first, second});
    }
    
    int64_t sign = 1;
    
    int64_t ans = 0;
    
    for (const auto& clock : clocks) {
        if (clock.first < clock.second) {
            ans += clock.first;
        } else {
            ans += clock.second;
            sign *= -1;
        }
    }
    
    if (sign == 1) {
        std::cout << ans << ENDL;
    } else {
        int64_t ans1 = std::numeric_limits<int64_t>::max();
        
        for (const auto& clock : clocks) {
            ans1 = std::min(ans1, ans - std::min(clock.first, clock.second) + std::max(clock.first, clock.second));
        }
        
        std::cout << ans1 << ENDL;
    }
}