// @maximka228
   
#pragma GCC optimize("O3") // the most "agressive" optimization
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
   
#include "bits/stdc++.h"
   
const int64_t MODULO = 1000000007;
const double PI = 3.14159265359;
const std::string ENDL = "\n";

// Hints:
// 1) Interval tasks solution ways: 1) prefix sums (prefix xors) or difference array 2) segment tree or fenwick tree 3) idea/constructive.
// 2) If the condition of the problem mentions 1) only 2 choices (for example, a problem about numbers consisting only of the digits 4 and 7) 2) any power of two (2, 4, 8 ...), then this is a bitmask problem.
// 3) Subsequences (array, string and so on) tasks solution ways: 1) DP 2) prefix sums (prefix xors) 3) two pointers.
   
// If you think, that your solution is correct, but you are still getting errors, check:
// 1) Overflow.
// 2) Such cases as n = 1 and so on. Also check task restrictions.
// 3) Memory usage.

std::set<int64_t> ok_nums;
 
bool check(int64_t a) {
    std::map<int64_t, int64_t> divisors;
    
    for (int64_t i = 2; i <= 100000; ++i) {
        if (a == 1) {
            break;
        }
        
        while (a % i == 0) {
            divisors[i]++;
            a /= i;
        }
    }
    
    if (a != 1) {
        divisors[a]++;
    }
    
    int64_t odd_counter = 0;
    
    for (const auto& [key, val] : divisors) {
        if (val % 2 == 1) {
            odd_counter++;
        }
    }
    
    return (odd_counter <= 1);
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
   
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int64_t n, m;
    std::cin >> n >> m;
    
    int64_t sum = 0;
    
    for (int64_t i = 1; i <= n; ++i) {
        sum += i;
    }
    
    int64_t groups_quantity = 3;
    
    if (check(sum)) {
        groups_quantity = 1;
    }
    
    int64_t found_num = -1;
    
    if (groups_quantity == 3) {
        for (int64_t i = 1; i <= n; ++i) {
            if (sum - i > 0 && check(sum - i) && check(i)) {
                groups_quantity = 2;
                found_num = i;
                break;
            }
        }
    }
    
    if (groups_quantity == 3) {
        std::cout << n << ENDL;
        return 0;
    }
    
    if (groups_quantity == 1) {
        std::cout << 1 << ENDL;

        std::cout << n << ENDL;

        for (int64_t i = 1; i <= n; ++i) {
            std::cout << i << " ";
        }
        std::cout << ENDL;
    } else {
        std::cout << 2 << ENDL;

        std::cout << 1 << ENDL;

        std::cout << found_num << ENDL;

        std::cout << n - 1 << ENDL;

        for (int64_t i = 1; i <= n; ++i) {
            if (i != found_num) {
                std::cout << i << " ";
            }
        }

        std::cout << ENDL;
    }
}