// @maximka228
   
#pragma GCC optimize("O3") // the most "agressive" optimization
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
   
#include "bits/stdc++.h"
   
const int64_t MODULO = 1000000007;
const double PI = 3.14159265359;
const std::string ENDL = "\n";

// Hints:
// 1) Interval tasks solution ways: 1) prefix sums (prefix xors) or difference array 2) segment tree or fenwick tree 3) idea/constructive.
// 2) If the condition of the problem mentions 1) only 2 choices (for example, a problem about numbers consisting only of the digits 4 and 7) 2) any power of two (2, 4, 8 ...), then this is a bitmask problem.
// 3) Subsequences (array, string and so on) tasks solution ways: 1) DP 2) prefix sums (prefix xors) 3) two pointers.
   
// If you think, that your solution is correct, but you are still getting errors, check:
// 1) Overflow.
// 2) Such cases as n = 1 and so on. Also check task restrictions.
// 3) Memory usage.

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
   
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int64_t n, m;
    std::cin >> n >> m;
    
    std::map<int64_t, int64_t> quantities;
    
    for (int64_t i = 0; i < n; ++i) {
        int64_t num;
        std::cin >> num;
        
        quantities[num]++;
    }
    
    std::vector<std::vector<int64_t>> matrix(m, std::vector<int64_t>(m));
    
    for (int64_t i = 0; i < m; ++i) {
        for (int64_t j = 0; j < m; ++j) {
            std::cin >> matrix[i][j];
        }
    }
    
    int64_t ans = std::numeric_limits<int64_t>::max();
    
    for (int64_t i = 0; i < m; ++i) {
        int64_t current = 0;
        
        for (int64_t j = 0; j < m; ++j) {
            current += matrix[i][j] * quantities[j + 1];
        }
        
        ans = std::min(current, ans);
    }
    
    std::cout << ans << ENDL;
}