// @maximka228
   
#pragma GCC optimize("O3") // the most "agressive" optimization
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
   
#include "bits/stdc++.h"
   
const int64_t MODULO = 1000000007;
const double PI = 3.14159265359;
const std::string ENDL = "\n";

// Hints:
// 1) Interval tasks solution ways: 1) prefix sums (prefix xors) or difference array 2) segment tree or fenwick tree 3) idea/constructive.
// 2) If the condition of the problem mentions 1) only 2 choices (for example, a problem about numbers consisting only of the digits 4 and 7) 2) any power of two (2, 4, 8 ...), then this is a bitmask problem.
// 3) Subsequences (array, string and so on) tasks solution ways: 1) DP 2) prefix sums (prefix xors) 3) two pointers.
   
// If you think, that your solution is correct, but you are still getting errors, check:
// 1) Overflow.
// 2) Such cases as n = 1 and so on. Also check task restrictions.
// 3) Memory usage.

std::vector<std::vector<int64_t>> edges;

std::vector<int64_t> distances;

void distance_dfs(int64_t node) {
    for (const auto& next : edges[node]) {
        if (!distances[next] && next != 1) {
            distances[next] = distances[node] + 1;
            distance_dfs(next);
        }
    }
}

std::vector<int64_t> profit;

std::vector<bool> used;

bool dfs(int64_t node, int64_t v, int64_t c) {
    if (node == v) {
        profit[node] += (distances[node] + 1) * c;
        return true;
    }
    
    bool is_ok = false;
    
    for (const auto& next : edges[node]) {
        if (!used[next]) {
            used[next] = true;
            
            bool status = dfs(next, v, c);
            
            if (status) {
                profit[node] += (distances[node] + 1) * c;
                is_ok = true;
            }
        }
    }
    
    return is_ok;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
   
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int64_t n;
    std::cin >> n;
    
    edges.resize(n + 1);
    
    for (int64_t i = 0; i < n - 1; ++i) {
        int64_t a, b;
        std::cin >> a >> b;
        
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    
    distances.resize(n + 1);
    distance_dfs(1);
    
    int64_t q, t;
    std::cin >> q >> t;
    
    while (q--) {
        int64_t k;
        std::cin >> k;
        
        profit.clear();
        profit.resize(n + 1);
        
        for (int64_t i = 0; i < k; ++i) {
            int64_t u, c;
            std::cin >> u >> c;
            
            used.clear();
            used.resize(n + 1);
            
            used[u] = true;
            dfs(u, 1, c);
        }
        
        int64_t ans = 0;
        
        for (const auto& num : profit) {
            ans = std::max(ans, num);
        }
        
        std::cout << ans << ENDL;
    }
}