#include <bits/stdc++.h>
using namespace std;
#define int long long
#define eb emplace_back
#define all(x) x.begin(), x.end()
#define endl '\n'
const int INF = 1e18, N = 400400, K = 19;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

vector<int> g[N];
int tin[N], tout[N], timer = 0, deep[N];
int renum[N] = {0}, rev[N] = {0}, s[N] = {0};
int up[K][N];
int used[N] = {0};

void precalc(int v, int p = 1) {
    tin[v] = timer++;
    up[0][v] = p;
    for (auto to : g[v]) {
        if (to == p)
            continue;
        deep[to] = deep[v] + 1;
        precalc(to, v);
    }
    tout[v] = timer++;
}

bool acs(int par, int v) {
    return tin[par] <= tin[v] && tout[v] <= tout[par];
}

int lca(int v, int u) {
    if (acs(v, u))
        return v;
    if (acs(u, v))
        return u;
    for (int i = K - 1; i >= 0; i--) {
        int w = up[i][v];
        if (!acs(w, u))
            v = w;
    }
    return up[0][v];
}

vector<vector<int>> sg;

bool cmp(int v, int u) {
    return tin[v] < tin[u];
}

void add_edge(int v, int u) {
    if (v == -1 || u == -1 || v == u)
        return;
    sg[renum[v]].eb(renum[u]);
    sg[renum[u]].eb(renum[v]);
}

void build(vector<int> a) {
    a.eb(1);
    sort(all(a), cmp);
    int m = (int) a.size();
    for (int i = 0; i < m; i++) {
        renum[a[i]] = i;
        rev[i] = a[i];
    }
    sg.assign(m, {});
    vector<int> st;
    st.eb(a.front());
    for (int i = 1; i < m; i++) {
        int l = lca(st.back(), a[i]);
        if (renum[l] == -1) {
            rev[m] = l;
            renum[l] = m++;
            sg.eb();
            a.eb(l);
        }
        int last = -1;
        while (!acs(st.back(), l)) {
            add_edge(st.back(), last);
            last = st.back();
            st.pop_back();
        }
        add_edge(l, last);
        if (l != st.back())
            st.eb(l);
        st.eb(a[i]);
    }
    int last = -1;
    while (!st.empty()) {
        add_edge(st.back(), last);
        last = st.back();
        st.pop_back();
    }
    for (auto it : a) {
        renum[it] = -1;
    }
}

int ans = 0, ans2 = 0;

int dfs(int v, int p = -1) {
    int res = s[rev[v]];
    used[v] = timer;
    for (auto to : sg[v]) {
        if (used[to] == timer)
            continue;
        res += dfs(to, v);
    }
    ans = max(ans, res * deep[rev[v]]);
    return res;
}

int susdfs(int v, int p = -1) {
    int res = s[v];
    for (auto to : g[v]) {
        if (to == p)
            continue;
        res += susdfs(to, v);
    }
    ans2 = max(ans2, deep[v] * res);
    return res;
}

void solve() {
    fill(renum, renum + N, -1);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[v].eb(u);
        g[u].eb(v);
    }
    deep[1] = 1;
    precalc(1);
    for (int i = 0; i < K - 1; i++) {
        for (int j = 1; j <= n; j++) {
            int v = up[i][j];
            up[i + 1][j] = up[i][v];
        }
    }
    int q, t;
    cin >> q >> t;
    int last = 0;
    while (q--) {
        timer++;
        int k;
        cin >> k;
        //k = rnd() % 5 + 1;
        vector<int> a(k);
        //vector<bool> used(n + 1);
        for (int i = 0; i < k; i++) {
            cin >> a[i];
            /*
            while (true) {
                a[i] = rnd() % n + 1;
                if (a[i] != 1 && !used[a[i]]) {
                    used[a[i]] = true;
                    break;
                }
            }
             */
            if (t == 2)
                a[i] = (a[i] + last) % (n - 1) + 2;
            cin >> s[a[i]];
            //s[a[i]] = rnd() % n + 1;
        }
        build(a);
        ans = 0;
        ans2 = 0;
        dfs(0);
        //susdfs(1);
        /*
        if (ans != ans2) {
            cout << ans << " " << ans2 << endl;
            cout << k << endl;
            for (int i = 0; i < k; i++) {
                cout << a[i] << " " << s[a[i]] << endl;
            }
            return;
        }
         */
        cout << ans << endl;
        for (int i = 0; i < k; i++) {
            s[a[i]] = 0;
        }
        last = ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
}


/*
16
1 2
2 4
2 7
4 15
7 16
1 3
3 5
5 8
8 9
9 11
1 6
6 12
6 13
6 14
1 10
1000 1
100 72
5
10 16
14 8
15 12
13 15
12 13
 */

/*
16
1 2
2 4
2 7
4 15
7 16
1 3
3 5
5 8
8 9
9 11
1 6
6 12
6 13
6 14
1 10
1 1
5
10 16
14 8
15 12
13 15
12 13
 */


/*
9
1 2
1 3
3 4
3 5
3 6
1 7
7 8
8 9
1 1
5
2 16
6 8
5 15
4 13
9 12
 */