#ifndef LOCALEGOR
#pragma optmize("Ofast")
#pragma target("avx2")
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

const int maxn = 5e5 + 31;
const int maxm = 1001;

int par[maxm];
vector<int> cost[maxm];
int a[maxn];

int n, m;

int find_par(int a) {
    if (a == par[a]) return a;
    return par[a] = find_par(par[a]);
}

bool unite(int a, int b) {
    a = find_par(a);
    b = find_par(b);
    if (a == b) return false;
    if (rnd() & 1) {
        par[a] = b;
        for (int i = 0; i < m; ++i) {
            cost[b][i] += cost[a][i];
        }
    } else {
        par[b] = a;
        for (int i = 0; i < m; ++i) {
            cost[a][i] += cost[b][i];
        }
    }
    return true;
}

void solve() {
    cin >> n >> m;
    vector<int> mxidx(m);
    vector<int> mnidx(m);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        mxidx[a[i]] = i;
    }
    for (int i = n - 1; i >= 0; --i) {
        mnidx[a[i]] = i;
    }
    for (int i = 0; i < m; ++i) {
        cost[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    for (int i = 0; i < m; ++i) {
        par[i] = i;
    }
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        if (i == mnidx[a[i]]) {
            if (sz(st)) {
                unite(st.back(), a[i]);
            }
            st.push_back(a[i]);
        }
        if (i == mxidx[a[i]]) {
            st.pop_back();
        }
    }
    for (int i = 0; i < n;) {
        for (int j = i; j <= mxidx[a[i]]; ++j) {
            unite(a[i], a[j]);
        }
        i = mxidx[a[i]] + 1;
    }
    vector<vector<int>> dp;
    vector<int> tmp(m);
    dp.push_back(cost[find_par(a[0])]);
    for (int i = 1; i < n; ++i) {
        if (find_par(a[i]) != find_par(a[i - 1])) {
            int mn = INF;
            for (int cur = 0; cur < m; ++cur) {
                mn = min(mn, dp.back()[cur]);
                tmp[cur] = mn + cost[find_par(a[i])][cur];
            }
            dp.push_back(tmp);
        }
    }
    cout << *min_element(all(dp.back())) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}