#ifndef LOCALEGOR
#pragma optmize("Ofast")
#pragma target("avx2")
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);


const int maxn = 4e5 + 2;

vector<int> g[maxn];
int tin[maxn];
int tout[maxn];
const int LOG = 23;
int up[LOG][maxn];
int timer = 0;
int h[maxn];
void dfs(int v, int p) {
    tin[v] = timer++;
    up[0][v] = p;
    if (v != p) {
        h[v] = h[p] + 1;
    }
    for (int l = 1; l < LOG; ++l) {
        up[l][v] = up[l - 1][up[l - 1][v]];
    }
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = timer;
}

bool ancestor(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (ancestor(a, b)) return a;
    if (ancestor(b, a)) return b;
    for(int l = LOG - 1; l >= 0; --l) {
        if (!ancestor(up[l][a], b)) a = up[l][a];
    }
    return up[0][a];
}

struct F {
    int n;
    vector<ll> t;
    F() {}
    F(int n) : n(n){
        t.resize(n);
    }
    void upd(int i, int x) {
        while (i < n) {
            t[i] += x;
            i |= i + 1;
        }
    }
    ll get(int i) {
        ll res = 0;
        while (~i) {
            res += t[i];
            i = (i & (i + 1)) - 1;
        }
        return res;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    int q, t;
    cin >> q >> t;
    F f(n);
    int last_ans = 0;
    if (t == 1) {
        for (int i = 0; i < q; ++i) {
            int k;
            cin >> k;
            vector<pair<int, int>> a(k);
            for (int j = 0; j < k; ++j) {
                cin >> a[j].first >> a[j].second;
                a[j].first -= 1;
            }
            sort(all(a),
                 [&](auto& x, auto& y) { return tin[x.first] < tin[y.first]; });
            for (int i = 0; i < k; ++i) {
                f.upd(tin[a[i].first], a[i].second);
            }
            ll ans = 0;
            for (int i = 0; i < k; ++i) {
                ans = max<ll>(ans, ((ll)h[a[i].first] + 1) * a[i].second);
            }
            for (int i = 1; i < k; ++i) {
                int v = lca(a[i - 1].first, a[i].first);
                ans = max(ans, f.get(tin[v], tout[v] - 1) * (h[v] + 1ll));
            }
            for (int i = 0; i < k; ++i) {
                f.upd(tin[a[i].first], -a[i].second);
            }
            cout << ans << '\n';
        }
    } else {
        for (int i = 0; i < q; ++i) {
            int k;
            cin >> k;
            vector<pair<int, int>> a(k);
            for (int j = 0; j < k; ++j) {
                cin >> a[j].first >> a[j].second;
                a[j].first = (a[j].first + last_ans) % (n - 1) + 1;
            }
            sort(all(a),
                 [&](auto& x, auto& y) { return tin[x.first] < tin[y.first]; });
            for (int i = 0; i < k; ++i) {
                f.upd(tin[a[i].first], a[i].second);
            }
            ll ans = 0;
            for (int i = 0; i < k; ++i) {
                ans = max<ll>(ans, ((ll)h[a[i].first] + 1) * a[i].second);
            }
            for (int i = 1; i < k; ++i) {
                int v = lca(a[i - 1].first, a[i].first);
                ans = max(ans, f.get(tin[v], tout[v] - 1) * (h[v] + 1ll));
            }
            for (int i = 0; i < k; ++i) {
                f.upd(tin[a[i].first], -a[i].second);
            }
            cout << ans << '\n';
            last_ans = ans;
        }
    }
    
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}