#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>

// #define LOCAL
#define int long long

using namespace std;

const int INF = 1e16 + 7;

vector<vector<int>> a;
vector<int> zero, up, down;

int get_even_zero() {
    if (zero.empty()) {
        return 0;
    }
    int res = 0, down_cnt = 0;
    for (int ind : zero) {
        if (a[ind][2] < a[ind][3]) {
            res += a[ind][2];
        } else {
            res += a[ind][3];
            down_cnt++;
        }
    }
    if (down_cnt % 2 == 0) {
        return res;
    }
    int delta = INF;
    for (int ind : zero) {
        delta = min(delta, abs(a[ind][2] - a[ind][3]));
    }
    return res + delta;
}

int get_odd_zero() {
    if (zero.empty()) {
        return INF;
    }
    int res = 0, down_cnt = 0;
    for (int ind : zero) {
        if (a[ind][2] < a[ind][3]) {
            res += a[ind][2];
        } else {
            res += a[ind][3];
            down_cnt++;
        }
    }
    if (down_cnt % 2 == 1) {
        return res;
    }
    int delta = INF;
    for (int ind : zero) {
        delta = min(delta, abs(a[ind][2] - a[ind][3]));
    }
    return res + delta;
}

int up_in_down() {
    if (up.empty()) {
        return INF;
    }
    int res = INF;
    for (int ind : up) {
        res = min(res, ((a[ind][0] + a[ind][1]) / a[ind][1]) * a[ind][3]);
    }
    return res;
}

int down_in_up() {
    if (down.empty()) {
        return INF;
    }
    int res = INF;
    for (int ind : down) {
        res = min(res, ((abs(a[ind][0]) + a[ind][1]) / a[ind][1]) * a[ind][2]);
    }
    return res;
}

inline void solve() {
    int n;
    cin >> n;
    a.resize(n, vector<int>(4));
    for (int j = 0; j < 4; j++) {
        for (int i = 0; i < n; i++) {
            cin >> a[i][j];
        }
    }
    int down_cnt = 0;
    for (int i = 0; i < n; i++) {
        if (a[i][0] == 0) {
            zero.push_back(i);
        } else if (a[i][0] > 0) {
            up.push_back(i);
        } else {
            down.push_back(i);
            down_cnt++;
        }
    }
    int res = INF;
    if (down_cnt % 2 == 0) {
        res = min(res, get_even_zero());
        res = min(res, get_odd_zero() + down_in_up());
        res = min(res, get_odd_zero() + up_in_down());
    } else {
        res = min(res, get_odd_zero());
        res = min(res, get_even_zero() + down_in_up());
        res = min(res, get_even_zero() + up_in_down());
    }
    assert(res != INF);
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    solve();
}