// temp.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <vector>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <fstream>
#include <string>
using namespace std;

vector<vector<long long>> cost;

class megaSymbol {
public:
	set<pair<long long, long long>> numbersOfSymb;

	megaSymbol(long long m) {
		
	}
	void add(long long col, long long cnt) {
		numbersOfSymb.insert(make_pair(col, cnt));
	}
	long long getCost(long long destCol) {
		long long ans = 0;
		for (auto i = numbersOfSymb.begin(); i != numbersOfSymb.end(); i++) {
			long long a = (*i).first;
			long long b = (*i).second;
			ans += cost[a][destCol];
		}
		
		return(ans);
	}
};

int main()
{
	long long n, m; cin >> n >> m;
	vector<long long> str(n);
	for (long long i = 0; i < n; i++) {
		cin >> str[i];
		str[i]--;
	}
	cost.resize(m, vector<long long>(m));
	for (long long i = 0; i < m; i++) {
		for (long long j = 0; j < m; j++) {
			cin >> cost[i][j];
		}
	}
	vector<pair<long long, long long>> edgesOfNumbs(m, make_pair(pow(10, 10), -1));
	for (long long i = 0; i < n; i++) {
		long long col = str[i];
		edgesOfNumbs[col].first = min(edgesOfNumbs[col].first, i);
		edgesOfNumbs[col].second = max(edgesOfNumbs[col].second, i);
	}
	vector<long long> cntOfSymb(m, 0);
	for (long long i = 0; i < n; i++) cntOfSymb[str[i]]++;

	vector<megaSymbol> SuperMass;
	long long theLeftLine = 0;
	long long theRightLine = 0;
	while (theLeftLine <= n - 1)
	{
		megaSymbol t = megaSymbol(m);

		while (theLeftLine <= theRightLine) {
			long long anotherCol = str[theLeftLine];
			theRightLine = max(theRightLine, edgesOfNumbs[anotherCol].second);
			t.add(anotherCol, cntOfSymb[anotherCol]);
			theLeftLine++;
		}

		SuperMass.push_back(t);
		theRightLine++;
	}
	long long k = SuperMass.size();
	vector<vector<long long>> field(k, vector<long long>(m, 0));
	field[0][0] = SuperMass[0].getCost(0);
	for (long long i = 1; i < m; i++) {
		field[0][i] = SuperMass[0].getCost(i);
		field[0][i] = min(field[0][i], field[0][i - 1]);
	}
	for (long long ik = 1; ik < k; ik++) {
		for (long long jm = 0; jm < m; jm++) {

			field[ik][jm] = field[ik - 1][jm] + SuperMass[ik].getCost(jm);
			if (jm > 0) {
				field[ik][jm] = min(field[ik][jm], field[ik][jm - 1]);
			}
		}
	}

	cout << field[k - 1][m - 1];

}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.