#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>


using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct seg {
    int l, r, c;


    bool operator<(const seg& other) const {
        if (l != other.l) return l < other.l;
        if (r != other.r) return r < other.r;
        return c < other.c;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> l(m, -1), r(m, -1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        if (l[a[i]] == -1) l[a[i]] = i;
        r[a[i]] = i;
    }
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    vector<seg> segs;
    for (int i = 0; i < m; ++i) {
        if (l[i] == -1) continue;
        segs.push_back({ l[i], r[i], i });
    }
    sort(segs.begin(), segs.end());
    vector<vector<seg>> groups;
    int right = segs[0].r;
    groups.push_back({segs[0]});
    for (int i = 1; i < segs.size(); ++i) {
        if (right < segs[i].l) {
            groups.push_back({ segs[i] });
            right = segs[i].r;
        }
        else {
            groups.back().push_back(segs[i]);
            right = max(right, segs[i].r);
        }
    }
    int cnt = groups.size();
    vector<vector<ll>> c(cnt, vector<ll>(m));
    for (int i = 0; i < cnt; ++i) {
        for (auto& s : groups[i]) {
            for (int j = 0; j < m; ++j) {
                c[i][j] += cost[s.c][j];
            }
        }
    }
    ll inf = 1e18;
    vector<vector<ll>> dp(cnt + 1, vector<ll>(m, inf)), minn(cnt + 1, vector<ll> (m, inf)); 
    for (int i = 0; i < m; ++i) {
        dp[0][i] = 0;
        minn[0][i] = 0;
    }
    for (int i = 1; i <= cnt; ++i) {
        for (int j = 0; j < m; ++j) {
            dp[i][j] = minn[i - 1][j] + c[i - 1][j];
        }
        minn[i][0] = dp[i][0];
        for (int j = 1; j < m; ++j) minn[i][j] = min(minn[i][j - 1], dp[i][j]);
    }
    ll ans = inf;
    for (int i = 0; i < m; ++i) ans = min(ans, dp[cnt][i]);
    cout << ans;
    return 0;
}