#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct ST {
    ll n;
    vector<ll> lg;
    vector<vector<ll>> st;
    ST(vector<ll> & arr) {
        n = (ll)arr.size();
        lg.resize(n + 10);
        for (ll i = 2; i < (ll)lg.size(); ++i) {
            lg[i] = lg[i / 2] + 1;
        }
        st.resize(lg[n] + 1, vector<ll>(n));
        for (ll i = 0; i < n; ++i) {
            st[0][i] = arr[i];
        }
        for (ll k = 1; k <= lg[n]; ++k) {
            for (ll i = 0; i + (1 << k) <= n; ++i) {
                st[k][i] = max(st[k - 1][i], st[k - 1][i + (1ll << (k - 1))]);
            }
        }
    }
    ll get(ll l, ll r) { // [l, r]
        ++r; ll t = lg[r - l];
        return max(st[t][l], st[t][r - (1ll << t)]);
    }
};

void solve(ll n, ll m, vector<vector<ll>> & cost) {
    vector<vector<ll>> dp(n, vector<ll>(m, LLONG_MAX));
    vector<ll> mn(m, LLONG_MAX);
    for (ll i = 0; i < m; ++i) {
        dp[0][i] = cost[0][i];
        if (i) {
            mn[i] = mn[i - 1];
        }
        mn[i] = min(mn[i], dp[0][i]);
    }
    for (ll i = 1; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            //for (ll k = 0; k <= j; ++k) {
            //    dp[i][j] = min(dp[i][j], dp[i - 1][k] + cost[i][j]);
            //}
            dp[i][j] = min(dp[i][j], mn[j] + cost[i][j]);
        }
        mn.assign(m, LLONG_MAX);
        for (int j = 0; j < m; ++j) {
            if (j) {
                mn[j] = mn[j - 1];
            }
            mn[j] = min(mn[j], dp[i][j]);
        }
    }
    ll ans = LLONG_MAX;
    for (ll i = 0; i < m; ++i) {
        ans = min(ans, dp[n - 1][i]);
    }
    cout << ans << endl;
}

signed main() {
    ll n, m; cin >> n >> m;
    vector<ll> arr(n);
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        cin >> arr[i]; --arr[i];
    }
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    vector<ll> last(m, -1); // последнее вхождение цвета arr[i]
    for (ll i = n - 1; i >= 0; --i) {
        last[arr[i]] = max(last[arr[i]], i);
    }
    vector<ll> nxt(n);
    for (ll i = 0; i < n; ++i) {
        nxt[i] = last[arr[i]];
    }
    ST st(nxt);
    vector<pair<ll, ll>> blocks;
    ll l = 0;
    while (l < n) {
        ll r = l;
        while (st.get(l, r) > r) {
            r = st.get(l, r);
        }
        blocks.push_back({l, r});
        l = r + 1;
    }
    vector<vector<ll>> ncost((ll)blocks.size(), vector<ll>(m));
    for (ll id = 0; id < (ll)blocks.size(); ++id) {
        auto [l, r] = blocks[id];
        set<ll> col;
        for (ll i = l; i <= r; ++i) {
            col.insert(arr[i]);
        }
        for (ll i = 0; i < m; ++i) {
            for (auto & c : col) {
                ncost[id][i] += cost[c][i];
            }
        }
    }
    solve((ll)blocks.size(), m, ncost);
    return 0;
}