#include <iostream>
#include <vector>
#include <climits>
// #define fastio
#define __GLIBCXX_DEBUG

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int n;
vector<vector<int>> seg_price;
vector<vector<int>> dp;
vector<int> arr;

void build_seg_price() {
    seg_price.resize(n, vector<int>(n, 0));
    for (int l = 0; l < n; ++l) {
        for (int r = l; r < n; ++r) {
            if (l == r) {
                seg_price[l][r] = max(arr[l], 0LL);
                continue;
            }
            int p = arr[l];
            int res = 0;
            for (int i = l + 1; i <= r; ++i) {
                int d = p;
                if (d > 0) {
                    res += d;
                    p = arr[i] - d;
                } else {
                    res += 0;
                    p = arr[i];
                }
            }
            if (p > 0) {
                res += p;
                p = 0;
            }
            seg_price[l][r] = res;
        }
    }
}

void build_dp() {
    dp.resize(n + 1, vector<int>(n, LLONG_MAX));
    for (int c = 1; c <= n; ++c) {
        for (int i = 0; i < n; ++i) {
            // пусть на позиции i стоит с-ый по счету плохой элемент
            int pr = 0;
            if (c == 1) {
                // тут стоит первый элемент
                if (i > 0) {
                    pr = seg_price[0][i - 1];
                }
            } else {
                pr = LLONG_MAX;
                // перебираем предыдущий плохой элемент
                for (int j = 0; j < i; ++j) {
                    if (dp[c - 1][j] == LLONG_MAX) continue;
                    int var = dp[c - 1][j];
                    if (j + 1 <= i - 1) {
                        var += seg_price[j + 1][i - 1];
                    }
                    pr = min(pr, var);
                }
            }
            dp[c][i] = pr;
        }
    }
}

signed main() {
    // #ifdef fastio
    // cin.tie(0);
    // ios::sync_with_stdio(0);
    // #endif
    // #ifdef ROMALOCAL
    // std::freopen("C:/Users/Sirius/Documents/vscode1/in.txt", "r", stdin);
    // std::freopen("C:/Users/Sirius/Documents/vscode1/out.txt", "w", stdout);
    // cout << "local run" << endl;
    // #endif

    cin >> n;
    arr.reserve(n - 1);
    int prev = INT_MAX;
    for (int i = 0; i < n; ++i) {
        int el;
        cin >> el;
        if (prev != INT_MAX) {
            arr.push_back(-1 * (prev + el) + 1);
        }
        prev = el;
    }
    --n;

    build_seg_price();
    build_dp();

    // return 0;


    for (int bad_cnt = 0; bad_cnt <= n; ++bad_cnt) {
        int res = 0;
        if (bad_cnt == 0) {
            res = seg_price[0][n - 1];
        } else {
            res = LLONG_MAX;
            for (int i = 0; i < n; ++i) {
                if (dp[bad_cnt][i] == LLONG_MAX) continue;
                int var = dp[bad_cnt][i];
                if (i + 1 <= n - 1) {
                    var += seg_price[i + 1][n - 1];
                }
                res = min(res, var);
            }
        }
        cout << res << " ";
    }
    cout << endl;

    return 0;
}