// #define __GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <climits>
#include <set>
#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int n, m, k;
vector<int> st;
vector<int> fn;
vector<int> arr;
vector<vector<int>> cost, cost2;
vector<vector<int>> segs;
vector<vector<int>> dp;

void resize() {
    st.resize(m, -1);
    fn.resize(m, -1);
    arr.resize(n);
    cost.resize(m, vector<int>(m));
}

void build_cost2() {
    cost2.resize(k, vector<int>(m, 0));
    for (int i = 0; i < k; ++i) {
        for (int t = 0; t < m; ++t) {
            for (const auto &j : segs[i]) {
                if (j == t) continue;
                cost2[i][t] += cost[j][t];
            }
        }
    }
}

void build_dp() {
    dp.resize(k, vector<int>(m, LLONG_MAX));
    for (int t = 0; t < m; ++t) {
        dp[0][t] = cost2[0][t];
        if (t > 0) dp[0][t] = min(dp[0][t], dp[0][t - 1]);
    }
    for (int i = 1; i < k; ++i) {
        for (int t = 0; t < m; ++t) {
            dp[i][t] = cost2[i][t] + dp[i - 1][t];
            if (t > 0) dp[i][t] = min(dp[i][t], dp[i][t - 1]);
        }
    }
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    std::freopen("C:/Users/Sirius/Documents/vscode1/in.txt", "r", stdin);
    std::freopen("C:/Users/Sirius/Documents/vscode1/out.txt", "w", stdout);
    cout << "local run" << endl;
    #endif

    cin >> n >> m;

    resize();

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        --arr[i];
        if (st[arr[i]] == -1) st[arr[i]] = i;
        fn[arr[i]] = i;
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }

    int i = 0;
    while (i < n) {
        set<int> els;
        int R = i;
        while (i <= R) {
            els.insert(arr[i]);
            R = max(R, fn[arr[i]]);
            ++i;
        }
        vector<int> els_vec;
        els_vec.reserve(els.size());
        for (const auto &el : els) {
            els_vec.push_back(el);
        }
        segs.push_back(els_vec);
    }

    k = segs.size();

    build_cost2();
    build_dp();

    int ans = LLONG_MAX;

    for (int t = 0; t < m; ++t) {
        ans = min(ans, dp[k - 1][t]);
    }
    
    cout << ans << endl;

    return 0;
}