#include <bits/stdc++.h>
#define int long long

using namespace std;

struct segtree{
    int sz;
    vector<int> t;

    void init(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        t.assign(2 * sz - 1, 0);
    }

    void set(int i, int v, int l, int r, int x) {
        if (r - l == 1) {
            t[x] = v;
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            set(i, v, l, m, 2 * x + 1);
        } else {
            set(i, v, m, r, 2 * x + 2);
        }
        t[x] = t[2 * x + 1] + t[2 * x + 2];
    }

    void set(int i, int v) {
        set(i, v, 0, sz, 0);
    }

    int sum(int ql, int qr, int l, int r, int x) {
        if (ql <= l && r <= qr) {
            return t[x];
        }
        if (ql >= r || l >= qr) {
            return 0;
        }
        int m = (l + r) / 2;
        return sum(ql, qr, l, m, 2 * x + 1) + sum(ql, qr, m, r, 2 * x + 2);
    }

    int sum(int l, int r) {
        return sum(l, r, 0, sz, 0);
    }
};

vector<vector<int>> g, up;
vector<int> h, p, tin, sz, tour;

const int lg = 23;

void dfs(int u, int par) {
    sz[u] = 1;
    tin[u] = tour.size();
    tour.push_back(u);
    for (auto& v : g[u]) {
        if (v != par) {
            h[v] = h[u] + 1;
            p[v] = u;
            dfs(v, u);
            sz[u] += sz[v];
        }
    }
}

int lca(int u, int v) {
    if (h[u] < h[v]) swap(u, v);
    for (int i = lg - 1; i >= 0; --i) {
        if (h[u] - h[v] >= 1ll << i) {
            u = up[i][u];
        }
    }
    if (u == v) return u;
    for (int i = lg - 1; i >= 0; --i) {
        if (up[i][u] != up[i][v]) {
            u = up[i][u];
            v = up[i][v];
        }
    }
    return up[0][u];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    g.assign(n, vector<int>());
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    h.assign(n, 1);
    p.assign(n, 0);
    tin.assign(n, 0);
    sz.assign(n, 0);
    dfs(0, 0);
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[tour[i]] = i;
    }
    up.assign(lg, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        up[0][i] = p[i];
    }
    for (int i = 1; i < lg; ++i) {
        for (int j = 0; j < n; ++j) {
            up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
    segtree sg;
    sg.init(n);
    segtree sg2;
    sg2.init(n);
    int q, t;
    cin >> q >> t;
    int last = 0;
    while (q--) {
        int k;
        cin >> k;
        vector<pair<int, pair<int, int>>> kar(k);
        for (int i = 0; i < k; ++i) {
            cin >> kar[i].second.first >> kar[i].second.second;
            if (t == 2) {
                kar[i].second.first = (kar[i].second.first + last) % (n - 1) + 1;
            } else {
                --kar[i].second.first;
            }
            kar[i].first = tin[kar[i].second.first];
            sg.set(pos[kar[i].second.first], kar[i].second.second);
            sg2.set(pos[kar[i].second.first], kar[i].second.second * h[kar[i].second.first]);
        }
        int res = 0;
        sort(kar.begin(), kar.end());
        for (int i = 0; i < k; ++i) {
            int u = kar[i].second.first;
            //cout << u << " " << sg2.sum(pos[u], pos[u] + sz[u]) << " " << sg.sum(pos[u], pos[u] + sz[u]) * h[u] << "\n";
            res = max(res, sg.sum(pos[u], pos[u] + sz[u]) * h[u]);
            if (i + 1 < k) {
                u = lca(u, kar[i + 1].second.first);
                res = max(res, sg.sum(pos[u], pos[u] + sz[u]) * h[u]);
            }
        }
        for (int i = 0; i < k; ++i) {
            int u = kar[i].second.first;
            sg.set(pos[u], 0);
            sg2.set(pos[u], 0);
        }
        cout << res << "\n";
        last = res;
    }
}