#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;

vector<vector<int>> g;
vector<int> used;
vector<ll> dp;
vector<ll> dep;

void dfs_d(int v, int d = 1) {
	dep[v] = d;
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u] == 0) {
			dfs_d(u, d + 1);
		}
	}
}

void dfs(int v, int p = -1) {
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v);
			dp[v] += dp[u];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	dep.resize(n, 0);
	used.resize(n, 0);
	dfs_d(0);
	int q, t;
	cin >> q >> t;
	ll last_ans = 0;
	while (q--) {
		dp.clear();
		dp.resize(n, 0);
		int k;
		cin >> k;
		for (int i = 0; i < k; ++i) {
			int x, c;
			cin >> x >> c;
			if (t == 1) {
				x--;
				dp[x] = c;
			}
			else {
				x = (x + last_ans) % (n - 1) + 1;
				dp[x] = c;
			}
		}
		dfs(0);
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			ans = max(ans, dp[i] * dep[i]);
		}
		cout << ans << '\n';
		last_ans = ans;
	}
}