#include "bits/stdc++.h"

using namespace std;

//@formatter:off
template<class T> istream &operator>>(istream &is, vector<T> &a);
template<class T> ostream &operator<<(ostream &os, const vector<T> &a);
//@formatter:on

const int N = 1e5 + 5;
vector<int> g[N], dist(N, -1);
set<int> path[N];

void dfs1(int u = 1, int p = 0) {
      path[u] = path[p];
      path[u].insert(u);
      dist[u] = dist[p] + 1;
      for (int v: g[u]) if (v != p) {
            dfs1(v, u);
      }
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      cin.tie(nullptr);
      ios_base::sync_with_stdio(false);
#endif
      int n;
      cin >> n;

      for (int i = 1; i < n; ++i) {
            int u, v;
            cin >>u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
      }

      dfs1();

      int q, t;
      cin >> q >> t;

      while (q--) {
            int k;
            cin >> k;
            vector<int> pl(n);
            for (int i = 0; i < k; ++i) {
                  int u, c;
                  cin >> u >> c;

                  for (auto v: path[u]) {
                        pl[v] += (dist[v] + 1) * c;
                  }
            }

            cout << *max_element(pl.begin(), pl.end()) << '\n';
      }
}

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { is >> some; });
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { os << some << ' '; });
      return (os << '\n');
}