#include <iomanip>
#include <string>
#include <algorithm>
#include <set>
#include <cmath>
#include <iostream>
#include <queue>
#include <map>
#include <random>
#include <vector>
using namespace std;
struct sob {
    int pos, sn;
};
bool cmp(sob a, sob b) {
    if (a.pos != b.pos) { return a.pos < b.pos; }
    return a.sn < b.sn;
}
vector <sob> events;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    long long n, m; cin >> n >> m;
    vector <int> colors(n);
    for (int i = 0; i < n; i++) { cin >> colors[i]; colors[i]--; }
    vector <vector<long long>> cnt(m, vector<long long>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cnt[i][j];
        }
    }
    vector <int> firstvh(m, -1), lastvh(m, -1);
    for (int i = 0; i < n; i++) {
        lastvh[colors[i]] = i;
        if (firstvh[colors[i]] == -1) { firstvh[colors[i]] = i; }
    }
    for (int i = 0; i < m; i++) {
        if (firstvh[i] != -1) {
            events.push_back({ firstvh[i], 1});
            events.push_back({ lastvh[i] + 1, -1 });
        }
    }
    sort(events.begin(), events.end(), cmp);
    vector <pair<int, int>> segments;
    int balance = 0, lotr = 0;
    for (auto elem : events) {
        int poss = elem.pos, ssn = elem.sn;
        balance += ssn;
        if (balance == 1 && ssn == 1) { lotr = poss; }
        if (balance == 0) {
            segments.push_back({ lotr, poss - 1 });
        }
    }
    //for (auto elem : segments) { cout << elem.first << " " << elem.second << "\n"; }
    vector <vector <long long>> dp(n, vector<long long>(m));
    for (int j = 0; j < m; j++) { dp[0][j] = cnt[colors[0]][j]; }
    int pos = 0;
    for (int i = 1; i < n; i++) {
        if (i > segments[pos].second) {
            pos++;
            long long minn = 10000000000000000;
            for (int j = 0; j < m; j++) {
                minn = min(minn, dp[i - 1][j]);
                dp[i][j] = minn + cnt[colors[i]][j];
            }
        }
        else {
            for (int j = 0; j < m; j++) {
                if (firstvh[colors[i]] == i) {
                    dp[i][j] = dp[i - 1][j] + cnt[colors[i]][j];
                } else { dp[i][j] = dp[i - 1][j]; }
            }
        }
    }
    long long ans = 10000000000000000;
    for (int j = 0; j < m; j++) {
        ans = min(ans, dp[n - 1][j]);
    }
    cout << ans;
    return 0;
}