#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

const int N = 2 * (int)1e5, inf = (int)1e9, mod = (int)1e9 + 7;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, pair<int, int>> wegde;

int binpow( int a, int p )
{
  int ans = 1;
  while (p)
  {
    if (p & 1)
      ans = (1ll * ans * p) % mod;
    a = (1ll * a * a) % mod;
    p >>= 1;
  }
  return ans;
}

int gcd( int a, int b, int &x, int &y )
{
  if (a == 0)
  {
    x = 0, y = 1;
    return b;
  }
  int x1, y1;
  int res = gcd(b % a, a, x1, y1);
  x = x1 - (b / a) * y1;
  y = y1;
  return res;
}

int main( void )
{
  int a, b, n, m;

  cin >> a >> b >> n >> m;

  if (2 * a == b)
    if (2 * n != m)
      cout << -1;
    else
      cout << n << " " << 0;
  else
  {
    int x = (2 * n - m) / (2 * a - b);
    if (x < 0)
      cout << -1;
    else
      if (x * (2 * a - b) != (2 * n - m))
        cout << -1;
      else
      {
        if (n < x * a)
          cout << -1;
        else
          cout << (n - x * a) << " " << x;
      }
  }

  return 0;
}