#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <iomanip>

using namespace std;

const int N = 2 * (int)1e5, inf = (int)1e9, mod = (int)1e9 + 7;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, pair<int, int>> wegde;

int binpow( int a, int p )
{
  int ans = 1;
  while (p)
  {
    if (p & 1)
      ans = (1ll * ans * p) % mod;
    a = (1ll * a * a) % mod;
    p >>= 1;
  }
  return ans;
}

int gcd( int a, int b, int &x, int &y )
{
  if (a == 0)
  {
    x = 0, y = 1;
    return b;
  }
  int x1, y1;
  int res = gcd(b % a, a, x1, y1);
  x = x1 - (b / a) * y1;
  y = y1;
  return res;
}

int pr[N];

int main( void )
{
  ll n, m;

  cin >> n >> m;

  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  ll n2 = 1ll * n * (n + 1) / 2;
  vector<int> a((int)n + 1);
  for (int i = 1; i < n + 1; i++)
    a[i] = 1;
  vector<vector<int>> v;

  fill(pr, pr + n + 1, 1);
  for (int i = 2; i <= n; i++)
    if (pr[i])
      for (int j = 2 * i; j <= n; j += i)
        pr[j] = 0;

  int size = 0;
  while (n2 > 0)
  {
    if (n2 <= n && pr[n2])
    {
      v.push_back({});
      for (int i = 1; i <= n; i++)
        if (a[i])
          v[size].push_back(i), a[i] = 0;
      size++;
      break;
    }
    ll mx = (ll)sqrt(n2);
    ll mx2 = mx * mx;
    int i = (int)n;
    ll old_n2 = n2;
    n2 -= mx2;
    v.push_back({});
    while (mx2 > 0)
    {
      if (i == 0)
      {
        for (int j = 0; j < (int)v[size].size(); j++)
          a[v[size][j]] = 1;
        v.pop_back();
        n2 = old_n2;
        mx--;
        v.push_back({});
        mx2 = mx * mx;
        n2 -= mx2;
        i = n;
        continue;
      }
      if (i > 0 && i <= mx2 && a[i])
      {
        mx2 -= i;
        a[i] = 0;
        v[size].push_back(i);
      }
      i--;
    }
    size++;
  }

  cout << v.size() << endl;
  for (int i = 0; i < size; i++)
  {
    cout << v[i].size() << endl;
    ll sum = 0;
    for (int j = 0; j < (int)v[i].size(); j++)
      cout << v[i][j] << " ", sum += v[i][j];
    ll sq = (ll)sqrt(sum);
    cout << endl;
  }
  return 0;
}