#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <iomanip>

using namespace std;

const int N = 500, inf = (int)1e9, mod = (int)1e9 + 7;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, pair<int, int>> wegde;

int binpow( int a, int p )
{
  int ans = 1;
  while (p)
  {
    if (p & 1)
      ans = (1ll * ans * p) % mod;
    a = (1ll * a * a) % mod;
    p >>= 1;
  }
  return ans;
}

int gcd( int a, int b, int &x, int &y )
{
  if (a == 0)
  {
    x = 0, y = 1;
    return b;
  }
  int x1, y1;
  int res = gcd(b % a, a, x1, y1);
  x = x1 - (b / a) * y1;
  y = y1;
  return res;
}

int dp[N];

int main( void )
{
  int n;
  cin >> n;

  vector<int> a(n), f(n), sum(n, 0);

  int cnt = 0;

  a[0] = -inf, a[n + 1] = -inf;
  for (int i = 0; i < n; i++)
    cin >> a[i];

  for (int i = 1; i < n; i++)
    if (a[i] + a[i - 1] <= 0)
      cnt++;

  for (int i = cnt; i < n; i++)
    dp[i] = 0;

  vector<wegde> w;

  for (int i = 1; i < n; i++)
    w.push_back({a[i] + a[i - 1], {i - 1, i}});

  sort(w.begin(), w.end());

  for (int i = cnt - 1; i >= 0; i++)
    dp[i] = dp[i + 1] + w[cnt - 1 - i].first;

  for (int i = 0; i <n; i++)
    cout << dp[i] << " ";

  return 0;
}