#include <iostream>
#include <deque>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <numeric>
#include <set>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pdd = pair<double, double>;
using lld = long double;
using db = double;
using pll = pair<ll, ll>;
const ll inf = 1e18;
const lld EPS = 1e-7;

void fastios() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
int tme = 0;
vector<int> d;
vector<bool> used;
void dfs(int v) {
    tin[v] = tme++;
    used[v] = true;
    for (auto to : g[v]) {
        if (used[to]) continue;
        d[to] = d[v] + 1;
        dfs(to);
    }
    tout[v] = tme++;
}

bool isanc(int v, int u) {
    return (tin[v] <= tin[u] && tout[u] <= tout[v]);
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    used.resize(n);
    tin.resize(n);
    tout.resize(n);
    d.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int q, t;
    cin >> q >> t;
    dfs(0);
    while (q--) {
        int k;
        cin >> k;
        vector<pii> b(k);
        for (int i = 0; i < k; i++) {
            cin >> b[i].first >> b[i].second;
            b[i].first--;
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            int nw = 0;
            for (auto [v, c] : b) {
                if (isanc(i, v))
                    nw += (d[i] + 1) * c;
            }
            ans = max(ans, nw);
        }
        cout << ans << endl;
    }
}

signed main() {
    /*freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);*/
    int tt = 1;
    //fastios();
    //precalc();
    //cin >> tt;
    while (tt--) {
        solve();
    }
}